module     p2_ddbar_emnebarcsbar_abbrevd8h1
   use p2_ddbar_emnebarcsbar_config, only: ki
   use p2_ddbar_emnebarcsbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb8n1
   complex(ki), public :: abb8n2
   complex(ki), public :: abb8n3
   complex(ki), public :: abb8n4
   complex(ki), public :: abb8n5
   complex(ki), public :: abb8n6
   complex(ki), public :: abb8n7
   complex(ki), public :: abb8n8
   complex(ki), public :: abb8n9
   complex(ki), public :: abb8n10
   complex(ki), public :: abb8n11
   complex(ki), public :: abb8n12
   complex(ki), public :: abb8n13
   complex(ki), public :: abb8n14
   complex(ki), public :: abb8n15
   complex(ki), public :: rat2d8
   complex(ki), public :: abb8n17
   complex(ki), public :: abb8n18
   complex(ki), public :: abb8n19
   complex(ki), public :: abb8n20
   complex(ki), public :: abb8n21
   complex(ki), public :: abb8n22
   complex(ki), public :: abb8n23
   complex(ki), public :: abb8n24
   complex(ki), public :: abb8n25
   complex(ki), public :: abb8n26
   complex(ki), public :: abb8n27
   complex(ki), public :: abb8n28
   complex(ki), public :: abb8n29
   complex(ki), public :: abb8n30
   complex(ki), public :: abb8n31
   complex(ki), public :: abb8n32
   complex(ki), public :: abb8n33
   complex(ki), public :: abb8n34
   complex(ki), public :: abb8n35
   complex(ki), public :: abb8n36
   complex(ki), public :: abb8n37
   complex(ki), public :: abb8n38
   complex(ki), public :: abb8n39
   complex(ki), public :: abb8n40
   complex(ki), public :: abb8n41
   complex(ki), public :: abb8n42
   complex(ki), public :: abb8n43
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p2_ddbar_emnebarcsbar_config, only: deltaOS
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_model
      use p2_ddbar_emnebarcsbar_color, only: TR
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak2k5
      t3 = t2*spak3k4
      t39 = TR*TR
      t4 = t39*t3*spbk4k1*spbk6k4
      t5 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t6 = es12*t5
      t7 = t4/t6
      t8 = t2*spak3k6
      t9 = t39*t8*spbk6k1*spbk6k4
      t10 = t9/t6
      t11 = -(t7+t10)
      t12 = NC*NC*t6
      t4 = t4/t12
      t9 = t9/t12
      t13 = c2*i_
      t14 = t13*spak2k5
      t15 = t14*spak3k4
      t5 = es12*NC*t5
      t16 = t39*t15/t5*spbk4k1*spbk6k4
      t14 = t14*spak3k6
      t17 = t39*t14/t5*spbk6k1*spbk6k4
      t18 = NC*c2
      t19 = t18*i_
      t20 = t19*spak2k5
      t21 = t20*spak3k4
      t22 = t39*t21/t6*spbk4k1*spbk6k4
      t23 = t20*spak3k6
      t24 = t39*t23/t6*spbk6k1*spbk6k4
      abb8n1 = ((2.0_ki)*(t11+t22+t24+t4+t9-(t17+t16)))
      t25 = es34*c1*i_*spak2k5
      t26 = es345*c1*i_*spak2k5
      t27 = es34*t18*i_*spak2k5
      t28 = es345*t18*i_*spak2k5
      t29 = es234*c1*i_*spak2k5
      t30 = es56*c1*i_*spak2k5
      t31 = es61*c1*i_*spak2k5
      t32 = t1*spak3k4
      t33 = TR*spak2k5
      t33 = t33*t33
      t34 = t1*spak3k6
      t35 = es234*t18*i_*spak2k5
      t36 = es56*t18*i_*spak2k5
      t18 = es61*t18*i_*spak2k5
      t37 = t19*spak3k4
      t38 = t19*spak3k6
      abb8n2 = ((4.0_ki)*(t39*t26/t6*spak3k4*spbk4k1*spbk6k4+t39*t26/t6*spak3k6*&
      &spbk6k1*spbk6k4+t39*t27/t6*spak3k4*spbk4k1*spbk6k4+t39*t27/t6*spak3k6*spb&
      &k6k1*spbk6k4-(t39*t28/t6*spak3k6*spbk6k1*spbk6k4+t39*t28/t6*spak3k4*spbk4&
      &k1*spbk6k4+t39*t25/t6*spak3k6*spbk6k1*spbk6k4+t39*t25/t6*spak3k4*spbk4k1*&
      &spbk6k4))+(2.0_ki)*(t39*t18/t6*spak3k4*spbk4k1*spbk6k4+t39*t18/t6*spak3k6&
      &*spbk6k1*spbk6k4+t39*t29/t6*spak3k4*spbk4k1*spbk6k4+t39*t29/t6*spak3k6*sp&
      &bk6k1*spbk6k4+t39*t30/t6*spak3k4*spbk4k1*spbk6k4+t39*t30/t6*spak3k6*spbk6&
      &k1*spbk6k4+t33*t37/t6*spbk4k2*spbk5k1*spbk6k4+t33*t38/t6*spbk5k1*spbk6k2*&
      &spbk6k4-(t39*t36/t6*spak3k6*spbk6k1*spbk6k4+t39*t36/t6*spak3k4*spbk4k1*sp&
      &bk6k4+t39*t35/t6*spak3k6*spbk6k1*spbk6k4+t39*t35/t6*spak3k4*spbk4k1*spbk6&
      &k4+t33*t34/t6*spbk5k1*spbk6k2*spbk6k4+t32*t33/t6*spbk4k2*spbk5k1*spbk6k4+&
      &t39*t31/t6*spak3k6*spbk6k1*spbk6k4+t39*t31/t6*spak3k4*spbk4k1*spbk6k4)))
      t18 = t1*spak2k3*spak2k5*spbk2k1
      t25 = t19*spak2k3*spak2k5*spbk2k1
      t26 = t2*spak3k5
      t27 = t26*spbk5k1
      t28 = t20*spak3k5
      t29 = t28*spbk5k1
      abb8n3 = ((12.0_ki)*(t39*t25/t6*spbk6k4-t39*t18/t6*spbk6k4)+(4.0_ki)*(t39*&
      &t27/t6*spbk6k4-t39*t29/t6*spbk6k4))
      abb8n4 = ((6.0_ki)*(t39*t18/t6*spbk6k3+t39*t1/t6*spak2k4*spak2k5*spbk2k1*s&
      &pbk6k4-(t39*t19/t6*spak2k4*spak2k5*spbk2k1*spbk6k4+t39*t25/t6*spbk6k3))+(&
      &2.0_ki)*(t39*t29/t6*spbk6k3+t39*t20/t6*spak4k5*spbk5k1*spbk6k4-(t39*t2/t6&
      &*spak4k5*spbk5k1*spbk6k4+t39*t27/t6*spbk6k3)))
      abb8n5 = ((6.0_ki)*(t39*t25/t6*spbk4k3+t39*t2/t6*spak2k6*spbk2k1*spbk6k4-(&
      &t39*t20/t6*spak2k6*spbk2k1*spbk6k4+t39*t18/t6*spbk4k3))+(2.0_ki)*(t39*t26&
      &/t6*spbk4k3*spbk5k1+t39*t2/t6*spak5k6*spbk5k1*spbk6k4-(t39*t20/t6*spak5k6&
      &*spbk5k1*spbk6k4+t39*t28/t6*spbk4k3*spbk5k1)))
      t2 = t10+t7
      abb8n6 = ((4.0_ki)*(t2-(t24+t22)))
      t7 = t1*spak1k2
      t10 = t13*spak1k2
      abb8n7 = ((4.0_ki)*(t39*t10/t5*spak3k4*spbk4k1*spbk6k4+t39*t10/t5*spak3k6*&
      &spbk6k1*spbk6k4-(t39/t12*t7*spak3k6*spbk6k1*spbk6k4+t39/t12*t7*spak3k4*sp&
      &bk4k1*spbk6k4)))
      abb8n8 = ((4.0_ki)*(t16+t17+t2-(t9+t4+t24+t22)))
      abb8n9 = ((4.0_ki)*(t11+t22+t24)+(8.0_ki)*(t16+t17-(t9+t4)))
      t2 = t1*spak1k5
      t4 = t39*t2*spak3k4*spbk4k1*spbk6k4
      t2 = t39*t2*spak3k6*spbk6k1*spbk6k4
      t3 = t39*t3*spbk4k2*spbk6k4
      t7 = t39*t8*spbk6k2*spbk6k4
      t8 = t13*spak1k5
      t9 = t19*spak1k5
      abb8n10 = ((4.0_ki)*(t2/t12+t3/t12+t4/t12+t7/t12+t2/t6+t3/t6+t4/t6+t7/t6-(&
      &t39/t6*t9*spak3k6*spbk6k1*spbk6k4+t39/t6*t9*spak3k4*spbk4k1*spbk6k4+t39/t&
      &5*t8*spak3k6*spbk6k1*spbk6k4+t39/t5*t8*spak3k4*spbk4k1*spbk6k4+t39*t23/t6&
      &*spbk6k2*spbk6k4+t39*t21/t6*spbk4k2*spbk6k4+t39*t15/t5*spbk4k2*spbk6k4+t3&
      &9*t14/t5*spbk6k2*spbk6k4)))
      t2 = t39*t32*spbk6k4
      abb8n11 = ((4.0_ki)*(t39*t37/t6*spbk6k4+t39*t13/t5*spak3k4*spbk6k4-(t2/t6+&
      &t2/t12)))
      t2 = t1*spak3k5
      t3 = t39*t2*spbk6k4
      t4 = t13*spak3k5
      t7 = t19*spak3k5
      abb8n12 = ((16.0_ki)*(t3/t12+t3/t6-(t39/t6*t7*spbk6k4+t39*t4/t5*spbk6k4)))
      t3 = t39*t34*spbk6k4
      abb8n13 = ((4.0_ki)*(t39*t38/t6*spbk6k4+t39*t13/t5*spak3k6*spbk6k4-(t3/t6+&
      &t3/t12)))
      t3 = t39*t2*spbk6k3
      t8 = t39*t1*spak4k5*spbk6k4
      abb8n14 = ((8.0_ki)*(t39*t4/t5*spbk6k3+t39/t6*t7*spbk6k3+t39*t13/t5*spak4k&
      &5*spbk6k4+t39*t19/t6*spak4k5*spbk6k4-(t8/t6+t3/t6+t8/t12+t3/t12)))
      t2 = t39*t2*spbk4k3
      t1 = t39*t1*spak5k6*spbk6k4
      abb8n15 = ((8.0_ki)*(t1/t12+t1/t6+t2/t12+t2/t6-(t39*t19/t6*spak5k6*spbk6k4&
      &+t39*t13/t5*spak5k6*spbk6k4+t39/t6*t7*spbk4k3+t39*t4/t5*spbk4k3)))
      rat2d8 = abb8n1
      rat2 = rat2 + rat2d8
      abb8n17 = abb8n2
      abb8n18 = abb8n15
      abb8n19 = abb8n14
      abb8n20 = abb8n13
      abb8n21 = abb8n12
      abb8n22 = abb8n11
      abb8n23 = abb8n10
      abb8n24 = abb8n9
      abb8n25 = abb8n8
      abb8n26 = abb8n7
      abb8n27 = abb8n6
      abb8n28 = abb8n5
      abb8n29 = abb8n4
      abb8n30 = abb8n3
      abb8n31 = -(abb8n3)
      abb8n32 = -(abb8n4)
      abb8n33 = -(abb8n5)
      abb8n34 = -(abb8n6)
      abb8n35 = -(abb8n7)
      abb8n36 = (-2.0_ki)*abb8n8
      abb8n37 = -(abb8n9)
      abb8n38 = -(abb8n10)
      abb8n39 = -(abb8n11)
      abb8n40 = -(abb8n12)
      abb8n41 = -(abb8n13)
      abb8n42 = -(abb8n14)
      abb8n43 = -(abb8n15)
   end subroutine
end module p2_ddbar_emnebarcsbar_abbrevd8h1
