module     p3_ud_emnebaruu_abbrevd17h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb17n1
   complex(ki), public :: abb17n2
   complex(ki), public :: abb17n3
   complex(ki), public :: abb17n4
   complex(ki), public :: abb17n5
   complex(ki), public :: abb17n6
   complex(ki), public :: abb17n7
   complex(ki), public :: abb17n8
   complex(ki), public :: abb17n9
   complex(ki), public :: abb17n10
   complex(ki), public :: abb17n11
   complex(ki), public :: rat2d17
   complex(ki), public :: abb17n13
   complex(ki), public :: abb17n14
   complex(ki), public :: abb17n15
   complex(ki), public :: abb17n16
   complex(ki), public :: abb17n17
   complex(ki), public :: abb17n18
   complex(ki), public :: abb17n19
   complex(ki), public :: abb17n20
   complex(ki), public :: abb17n21
   complex(ki), public :: abb17n22
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   real(ki) :: t36
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak3k5
      t4 = t3*spak3k6
      t36 = TR*TR
      t5 = t36*t4*spbk2k1*spbk4k3
      t6 = es345*t1
      t7 = es61*t6
      t8 = t5/t7
      t9 = t3*spak5k6
      t10 = t36*t9*spbk2k1*spbk5k4
      t11 = t10/t7
      t12 = t11-t8
      t13 = NC*NC*t7
      t14 = t5/t13
      t15 = t10/t13
      t16 = c1*i_
      t17 = t16*spak3k5
      t18 = es61*es345*NC*t1
      t19 = t36*t17/t18*spak3k6*spbk2k1*spbk4k3
      t20 = t36*t17/t18*spak5k6*spbk2k1*spbk5k4
      t21 = NC*c1
      t22 = t21*i_
      t23 = t22*spak3k5
      t24 = t23*spak3k6
      t25 = t36*t24*spbk2k1*spbk4k3
      t26 = t25/t7
      t27 = t23*spak5k6
      t28 = t36*t27*spbk2k1*spbk5k4
      t29 = t28/t7
      abb17n1 = ((2.0_ki)*(t12+t14+t20+t26-(t29+t19+t15)))
      t1 = es61*t1
      t30 = es12*c2*i_*spak3k5
      t31 = t2*spak1k3
      t32 = TR*spbk2k1
      t32 = t32*t32
      t33 = t2*spak1k5
      t21 = es12*t21*i_*spak3k5
      t34 = t22*spak1k3
      t35 = t22*spak1k5
      abb17n2 = ((2.0_ki)*(t10/t1+t25/t1+t28/t6+t5/t6+t36*t21/t7*spak3k6*spbk2k1&
      &*spbk4k3+t36*t30/t7*spak5k6*spbk2k1*spbk5k4+t31*t32/t7*spak2k6*spak3k5*sp&
      &bk4k3+t32*t35/t7*spak2k6*spak3k5*spbk5k4-(t32*t34/t7*spak2k6*spak3k5*spbk&
      &4k3+t32*t33/t7*spak2k6*spak3k5*spbk5k4+t36*t30/t7*spak3k6*spbk2k1*spbk4k3&
      &+t36*t21/t7*spak5k6*spbk2k1*spbk5k4+t25/t6+t10/t6+t5/t1+t28/t1)))
      abb17n3 = ((8.0_ki)*(t12+t26-t29))
      t1 = t8-t11
      abb17n4 = ((8.0_ki)*(t1+t29-t26))
      t4 = t4*spbk4k3
      t5 = t9*spbk5k4
      t6 = t24*spbk4k3
      t8 = t27*spbk5k4
      abb17n5 = ((6.0_ki)*(t36*t4/t7*spbk6k1+t36/t7*t8*spbk6k1-(t36*t6/t7*spbk6k&
      &1+t36*t5/t7*spbk6k1))+(2.0_ki)*(t36*t2/t7*spak2k5*spak3k5*spbk2k1*spbk5k4&
      &+t36*t22/t7*spak2k3*spak3k5*spbk2k1*spbk4k3-(t36*t22/t7*spak2k5*spak3k5*s&
      &pbk2k1*spbk5k4+t36*t2/t7*spak2k3*spak3k5*spbk2k1*spbk4k3)))
      abb17n6 = ((2.0_ki)*(t36*t5/t7*spbk6k2+t36*t6/t7*spbk6k2+t36*t31/t7*spak3k&
      &5*spbk2k1*spbk4k3+t36*t35/t7*spak3k5*spbk2k1*spbk5k4-(t36*t34/t7*spak3k5*&
      &spbk2k1*spbk4k3+t36*t33/t7*spak3k5*spbk2k1*spbk5k4+t36/t7*t8*spbk6k2+t36*&
      &t4/t7*spbk6k2)))
      t2 = t2*spak1k6*spak3k5*spbk2k1
      t4 = t16*spak1k6*spak3k5*spbk2k1
      abb17n7 = ((4.0_ki)*(t36/t18*t4*spbk4k3-t36*t2/t13*spbk4k3))
      abb17n8 = ((4.0_ki)*(t36*t2/t13*spbk5k4-t36/t18*t4*spbk5k4))
      abb17n9 = ((4.0_ki)*(t1+t15+t19+t29-(t26+t20+t14)))
      t1 = t36*t3*spbk4k3
      abb17n10 = ((4.0_ki)*(t36*t17/t18*spbk4k3+t36*t23/t7*spbk4k3-(t1/t7+t1/t13&
      &)))
      t1 = t36*t3*spbk5k4
      abb17n11 = ((4.0_ki)*(t1/t13+t1/t7-(t36*t23/t7*spbk5k4+t36*t17/t18*spbk5k4&
      &)))
      rat2d17 = abb17n1
      rat2 = rat2 + rat2d17
      abb17n13 = abb17n2
      abb17n14 = abb17n11
      abb17n15 = abb17n10
      abb17n16 = abb17n9
      abb17n17 = abb17n8
      abb17n18 = abb17n7
      abb17n19 = abb17n6
      abb17n20 = abb17n5
      abb17n21 = abb17n4
      abb17n22 = abb17n3
   end subroutine
end module p3_ud_emnebaruu_abbrevd17h0
