module     p3_ud_emnebaruu_abbrevd39h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb39n1
   complex(ki), public :: abb39n2
   complex(ki), public :: abb39n3
   complex(ki), public :: abb39n4
   complex(ki), public :: abb39n5
   complex(ki), public :: abb39n6
   complex(ki), public :: abb39n7
   complex(ki), public :: abb39n8
   complex(ki), public :: abb39n9
   complex(ki), public :: abb39n10
   complex(ki), public :: abb39n11
   complex(ki), public :: abb39n12
   complex(ki), public :: abb39n13
   complex(ki), public :: rat2d39
   complex(ki), public :: abb39n15
   complex(ki), public :: abb39n16
   complex(ki), public :: abb39n17
   complex(ki), public :: abb39n18
   complex(ki), public :: abb39n19
   complex(ki), public :: abb39n20
   complex(ki), public :: abb39n21
   complex(ki), public :: abb39n22
   complex(ki), public :: abb39n23
   complex(ki), public :: abb39n24
   complex(ki), public :: abb39n25
   complex(ki), public :: abb39n26
   complex(ki), public :: abb39n27
   complex(ki), public :: abb39n28
   complex(ki), public :: abb39n29
   complex(ki), public :: abb39n30
   complex(ki), public :: abb39n31
   complex(ki), public :: abb39n32
   complex(ki), public :: abb39n33
   complex(ki), public :: abb39n34
   complex(ki), public :: abb39n35
   complex(ki), public :: abb39n36
   complex(ki), public :: abb39n37
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   real(ki) :: t41
   real(ki) :: t42
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak5k6
      t5 = t4*spbk2k1*spbk4k2
      t41 = TR*mT
      t41 = t41*t41
      t6 = es234*t1
      t42 = es61*es61
      t7 = t42*t6
      t8 = t2*spak3k4
      t9 = t8*spak5k6
      t10 = t9*spbk4k1*spbk4k2
      t11 = t2*spak3k5
      t12 = t11*spak3k6
      t13 = t12*spbk2k1*spbk4k3
      t14 = es345*t1
      t15 = t42*t14
      t16 = t11*spak5k6
      t17 = t16*spbk2k1*spbk5k4
      t18 = c2*i_
      t19 = t18*spak2k3
      t20 = t19*spak5k6
      t21 = t20*spbk2k1*spbk4k2
      t1 = NC*t1
      t22 = es234*t1
      t23 = t42*t22
      t24 = t18*spak3k4
      t25 = t24*spak5k6
      t26 = t25*spbk4k1*spbk4k2
      t27 = t18*spak3k5
      t28 = t27*spak3k6
      t29 = t28*spbk2k1*spbk4k3
      t1 = es345*t1
      t30 = t42*t1
      t31 = t27*spak5k6
      t32 = t31*spbk2k1*spbk5k4
      t42 = TR*TR
      t33 = t42*t5
      t6 = es61*t6
      t34 = t42*t10
      t35 = t42*t13
      t14 = es61*t14
      t36 = t42*t17
      t37 = t42*t21
      t22 = es61*t22
      t38 = t42*t26
      t39 = t42*t29
      t1 = es61*t1
      t40 = t42*t32
      abb39n1 = ((4.0_ki/3.0_ki)*(t39/t1+t36/t14+t33/t6+t34/t6-(t38/t22+t37/t22+&
      &t35/t14+t40/t1))+(8.0_ki)*(t41*t13/t15+t41*t21/t23+t41*t26/t23+t41*t32/t3&
      &0-(t41*t5/t7+t41*t29/t30+t41*t17/t15+t41*t10/t7)))
      t1 = TR*sqrt((mT*mT))
      t1 = t1*t1
      abb39n2 = ((8.0_ki)*(t1*t13/t15+t1*t21/t23+t1/t23*t26+t1/t30*t32-(t1*t5/t7&
      &+t1*t29/t30+t1/t15*t17+t1*t10/t7)))
      t1 = t2*spak1k6
      t5 = t1*spak3k5*spbk2k1
      t6 = t18*spak1k6
      t10 = t6*spak3k5*spbk2k1
      abb39n3 = ((4.0_ki)*(t42*t10/t30*spbk4k3-t42/t15*t5*spbk4k3))
      abb39n4 = ((8.0_ki)*(t42*t27/t30*spbk4k3-t42*t11/t15*spbk4k3))
      abb39n5 = ((4.0_ki)*(t42/t15*t5*spbk5k4+t42*t1/t7*spak2k3*spbk2k1*spbk4k2+&
      &t42*t1/t7*spak3k4*spbk4k1*spbk4k2-(t42/t23*t6*spak3k4*spbk4k1*spbk4k2+t42&
      &/t23*t6*spak2k3*spbk2k1*spbk4k2+t42*t10/t30*spbk5k4)))
      t1 = t33/t7
      t5 = t34/t7
      t6 = t35/t15
      t10 = t36/t15
      t13 = t37/t23
      t14 = t38/t23
      t17 = t39/t30
      t21 = t40/t30
      abb39n6 = ((16.0_ki)*(t13+t14+t21+t6-(t5+t17+t10+t1)))
      t1 = t1+t10+t17+t5-(t6+t21+t14+t13)
      abb39n7 = ((8.0_ki)*t1)
      abb39n8 = ((16.0_ki)*t1)
      t1 = t4*spbk4k2
      t4 = t12*spbk4k3
      t5 = t16*spbk5k4
      t6 = t20*spbk4k2
      t10 = t28*spbk4k3
      t12 = t31*spbk5k4
      abb39n9 = ((4.0_ki)*(t42*t12/t30*spbk6k1+t42*t4/t15*spbk6k1+t42/t23*t6*spb&
      &k6k1-(t42/t15*t5*spbk6k1+t42*t10/t30*spbk6k1+t42*t1/t7*spbk6k1)))
      t9 = t9*spbk4k2
      t13 = t25*spbk4k2
      abb39n10 = ((4.0_ki)*(t42*t13/t23*spbk6k1-t42/t7*t9*spbk6k1))
      abb39n11 = ((8.0_ki)*(t42*t11/t15*spbk5k4+t42*t3/t7*spbk4k2-(t42*t27/t30*s&
      &pbk5k4+t42*t19/t23*spbk4k2)))
      t3 = t2*spak1k5
      t11 = t18*spak1k5
      abb39n12 = ((8.0_ki)*(t42*t1/t7*spbk6k2+t42*t10/t30*spbk6k2+t42/t15*t5*spb&
      &k6k2+t42/t7*t9*spbk6k4+t42*t11/t23*spak2k3*spbk2k1*spbk4k2+t42*t11/t23*sp&
      &ak3k4*spbk4k1*spbk4k2+t42*t11/t30*spak3k5*spbk2k1*spbk5k4+t42*t2/t15*spak&
      &1k3*spak3k5*spbk2k1*spbk4k3-(t42*t18/t30*spak1k3*spak3k5*spbk2k1*spbk4k3+&
      &t42*t3/t7*spak3k4*spbk4k1*spbk4k2+t42*t3/t7*spak2k3*spbk2k1*spbk4k2+t42*t&
      &3/t15*spak3k5*spbk2k1*spbk5k4+t42/t23*t6*spbk6k2+t42*t4/t15*spbk6k2+t42*t&
      &13/t23*spbk6k4+t42*t12/t30*spbk6k2)))
      abb39n13 = ((8.0_ki)*(t42/t7*t8*spbk4k2-t42*t24/t23*spbk4k2))
      rat2d39 = abb39n1
      rat2 = rat2 + rat2d39
      abb39n15 = abb39n2
      abb39n16 = abb39n13
      abb39n17 = abb39n12
      abb39n18 = abb39n11
      abb39n19 = abb39n10
      abb39n20 = abb39n9
      abb39n21 = abb39n8
      abb39n22 = abb39n7
      abb39n23 = abb39n6
      abb39n24 = abb39n5
      abb39n25 = abb39n4
      abb39n26 = abb39n3
      abb39n27 = -(abb39n3)
      abb39n28 = -(abb39n4)
      abb39n29 = -(abb39n5)
      abb39n30 = -(abb39n6)
      abb39n31 = (-2.0_ki)*abb39n7
      abb39n32 = -(abb39n8)
      abb39n33 = -(abb39n9)
      abb39n34 = -(abb39n10)
      abb39n35 = -(abb39n11)
      abb39n36 = -(abb39n12)
      abb39n37 = -(abb39n13)
   end subroutine
end module p3_ud_emnebaruu_abbrevd39h0
