module     p3_ud_emnebaruu_abbrevd59h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb59n1
   complex(ki), public :: abb59n2
   complex(ki), public :: abb59n3
   complex(ki), public :: abb59n4
   complex(ki), public :: abb59n5
   complex(ki), public :: abb59n6
   complex(ki), public :: abb59n7
   complex(ki), public :: abb59n8
   complex(ki), public :: abb59n9
   complex(ki), public :: abb59n10
   complex(ki), public :: abb59n11
   complex(ki), public :: abb59n12
   complex(ki), public :: abb59n13
   complex(ki), public :: abb59n14
   complex(ki), public :: abb59n15
   complex(ki), public :: abb59n16
   complex(ki), public :: abb59n17
   complex(ki), public :: rat2d59
   complex(ki), public :: abb59n19
   complex(ki), public :: abb59n20
   complex(ki), public :: abb59n21
   complex(ki), public :: abb59n22
   complex(ki), public :: abb59n23
   complex(ki), public :: abb59n24
   complex(ki), public :: abb59n25
   complex(ki), public :: abb59n26
   complex(ki), public :: abb59n27
   complex(ki), public :: abb59n28
   complex(ki), public :: abb59n29
   complex(ki), public :: abb59n30
   complex(ki), public :: abb59n31
   complex(ki), public :: abb59n32
   complex(ki), public :: abb59n33
   complex(ki), public :: abb59n34
   complex(ki), public :: abb59n35
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   real(ki) :: t36
   real(ki) :: t37
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak5k6
      t36 = TR*TR
      t5 = t36*t4*spbk2k1*spbk4k2
      t6 = NC*t1
      t7 = t2*spak3k4
      t8 = t7*spak5k6
      t9 = t36*t8*spbk4k1*spbk4k2
      t10 = es56*c1*i_
      t11 = es234*t6
      t12 = es61*c1*i_
      t13 = c2*i_
      t14 = t13*spak2k3
      t15 = t14*spak5k6
      t16 = t36*t15*spbk2k1*spbk4k2
      t37 = NC*NC
      t17 = t37*t1
      t18 = t13*spak3k4
      t19 = t18*spak5k6
      t20 = t36*t19*spbk4k1*spbk4k2
      t21 = NC*c1
      t22 = t21*i_
      t23 = t22*spak2k3
      t24 = t23*spak5k6
      t25 = t36*t24*spbk2k1*spbk4k2
      t26 = t22*spak3k4
      t27 = t26*spak5k6
      t28 = t36*t27*spbk4k1*spbk4k2
      t29 = es56*c2*i_
      t30 = es234*t1
      t31 = t37*t30
      t32 = es61*c2*i_
      t33 = es56*t21*i_
      t21 = es61*t21*i_
      abb59n1 = ((8.0_ki)*(t5/t6+t9/t6-(t36*t12/t11*spak3k4*spak5k6*spbk4k1*spbk&
      &4k2+t36*t12/t11*spak2k3*spak5k6*spbk2k1*spbk4k2+t36*t10/t11*spak3k4*spak5&
      &k6*spbk4k1*spbk4k2+t36*t10/t11*spak2k3*spak5k6*spbk2k1*spbk4k2))+(4.0_ki)&
      &*(t36*t21/t30*spak2k3*spak5k6*spbk2k1*spbk4k2+t36*t21/t30*spak3k4*spak5k6&
      &*spbk4k1*spbk4k2+t36*t29/t31*spak2k3*spak5k6*spbk2k1*spbk4k2+t36*t29/t31*&
      &spak3k4*spak5k6*spbk4k1*spbk4k2+t36*t33/t30*spak2k3*spak5k6*spbk2k1*spbk4&
      &k2+t36*t33/t30*spak3k4*spak5k6*spbk4k1*spbk4k2+t36*t32/t31*spak2k3*spak5k&
      &6*spbk2k1*spbk4k2+t36*t32/t31*spak3k4*spak5k6*spbk4k1*spbk4k2-(t20/t17+t1&
      &6/t17+t28/t1+t25/t1)))
      t1 = NC*c2*i_
      t6 = t1*spak2k3
      t10 = t6*spak5k6
      t12 = t1*spak3k4
      t17 = t12*spak5k6
      abb59n2 = ((16.0_ki)*(-(t20/t11+t16/t11))+(8.0_ki)*(t5/t31+t9/t31+t36*t10/&
      &t30*spbk2k1*spbk4k2+t36*t17/t30*spbk4k1*spbk4k2))
      t21 = t2*spak3k5
      t29 = t36*t21/t31*spbk4k2
      t32 = t13*spak3k5
      t33 = t36*(2.0_ki)/t11*t32*spbk4k2
      t34 = t1*spak3k5
      t35 = t36*t34/t30*spbk4k2
      abb59n3 = ((8.0_ki)*(t29+t35-t33))
      abb59n4 = ((8.0_ki)*(t33-(t35+t29)))
      abb59n5 = ((8.0_ki)*(t36*t32/t11*spbk3k2+t36*t13/t11*spak4k5*spbk4k2)+(4.0&
      &_ki)*(-(t36*t2/t31*spak4k5*spbk4k2+t36*t1/t30*spak4k5*spbk4k2+t36*t34/t30&
      &*spbk3k2+t36*t21/t31*spbk3k2)))
      abb59n6 = ((8.0_ki)*(t36*t32/t11*spbk4k3-t36*t13/t11*spak2k5*spbk4k2)+(4.0&
      &_ki)*(t36*t1/t30*spak2k5*spbk4k2+t36*t2/t31*spak2k5*spbk4k2-(t36*t34/t30*&
      &spbk4k3+t36*t21/t31*spbk4k3)))
      t1 = t2*spak1k5
      t15 = t15*spbk4k2
      t19 = t19*spbk4k2
      t4 = t4*spbk4k2
      t8 = t8*spbk4k2
      t21 = t13*spak1k5
      t29 = t22*spak1k5
      abb59n7 = ((8.0_ki)*(-(t36*t1/t11*spak3k4*spbk4k1*spbk4k2+t36*t1/t11*spak2&
      &k3*spbk2k1*spbk4k2+t36*t19/t11*spbk6k4+t36*t15/t11*spbk6k2))+(4.0_ki)*(t3&
      &6/t31*t4*spbk6k2+t36/t31*t8*spbk6k4+t36*t10/t30*spbk4k2*spbk6k2+t36*t17/t&
      &30*spbk4k2*spbk6k4+t36*t21/t31*spak2k3*spbk2k1*spbk4k2+t36*t21/t31*spak3k&
      &4*spbk4k1*spbk4k2+t36*t29/t30*spak2k3*spbk2k1*spbk4k2+t36*t29/t30*spak3k4&
      &*spbk4k1*spbk4k2))
      abb59n8 = ((16.0_ki)*(t5/t11+t9/t11)+(8.0_ki)*(-(t28/t30+t25/t30+t20/t31+t&
      &16/t31)))
      t1 = t36*t3*spbk4k2
      t3 = t1/t11
      t5 = t36*t14*spbk4k2
      t9 = t5/t11
      t1 = t1/t31
      t5 = t5/t31
      t10 = t36*t23/t30*spbk4k2
      t6 = t36/t30*t6*spbk4k2
      abb59n9 = ((8.0_ki)*(-(t9+t3))+(4.0_ki)*(t1+t10+t5+t6))
      abb59n10 = ((8.0_ki)*(t3+t9)+(4.0_ki)*(-(t6+t5+t10+t1)))
      abb59n11 = ((8.0_ki)*(t36/t11*t4*spbk5k2+t36/t11*t8*spbk5k4)+(4.0_ki)*(-(t&
      &36*t27/t30*spbk4k2*spbk5k4+t36*t24/t30*spbk4k2*spbk5k2+t36*t19/t31*spbk5k&
      &4+t36*t15/t31*spbk5k2)))
      t1 = t36*t7*spbk4k2
      t3 = t1/t11
      t4 = t36*t18*spbk4k2
      t5 = t4/t11
      t1 = t1/t31
      t4 = t4/t31
      t6 = t36*t26/t30*spbk4k2
      t7 = t36*t12/t30*spbk4k2
      abb59n12 = ((8.0_ki)*(-(t5+t3))+(4.0_ki)*(t1+t4+t6+t7))
      abb59n13 = ((8.0_ki)*(t3+t5)+(4.0_ki)*(-(t7+t6+t4+t1)))
      t1 = t13*spak3k6
      t3 = t36*t1/t31*spbk4k2
      t4 = t2*spak3k6
      t5 = t36*(2.0_ki)/t11*t4*spbk4k2
      t6 = t22*spak3k6
      t7 = t36/t30*t6*spbk4k2
      abb59n14 = ((8.0_ki)*(t3+t7-t5))
      abb59n15 = ((8.0_ki)*(t5-(t7+t3)))
      abb59n16 = ((8.0_ki)*(-(t36*t2/t11*spak4k6*spbk4k2+t36/t11*t4*spbk3k2))+(4&
      &.0_ki)*(t36*t1/t31*spbk3k2+t36/t30*t6*spbk3k2+t36*t13/t31*spak4k6*spbk4k2&
      &+t36*t22/t30*spak4k6*spbk4k2))
      abb59n17 = ((8.0_ki)*(t36*t2/t11*spak2k6*spbk4k2-t36/t11*t4*spbk4k3)+(4.0_&
      &ki)*(t36*t1/t31*spbk4k3+t36/t30*t6*spbk4k3-(t36*t22/t30*spak2k6*spbk4k2+t&
      &36*t13/t31*spak2k6*spbk4k2)))
      rat2d59 = 0
      rat2 = rat2 + rat2d59
      abb59n19 = abb59n1
      abb59n20 = abb59n17
      abb59n21 = abb59n16
      abb59n22 = abb59n15
      abb59n23 = abb59n14
      abb59n24 = abb59n13
      abb59n25 = abb59n12
      abb59n26 = abb59n10
      abb59n27 = abb59n9
      abb59n28 = abb59n6
      abb59n29 = abb59n5
      abb59n30 = abb59n4
      abb59n31 = abb59n3
      abb59n32 = -(abb59n2)
      abb59n33 = -(abb59n7)
      abb59n34 = -(abb59n8)
      abb59n35 = -(abb59n11)
   end subroutine
end module p3_ud_emnebaruu_abbrevd59h0
