module     p3_ud_emnebaruu_abbrevd9h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb9n1
   complex(ki), public :: abb9n2
   complex(ki), public :: abb9n3
   complex(ki), public :: abb9n4
   complex(ki), public :: abb9n5
   complex(ki), public :: abb9n6
   complex(ki), public :: abb9n7
   complex(ki), public :: abb9n8
   complex(ki), public :: abb9n9
   complex(ki), public :: abb9n10
   complex(ki), public :: abb9n11
   complex(ki), public :: rat2d9
   complex(ki), public :: abb9n13
   complex(ki), public :: abb9n14
   complex(ki), public :: abb9n15
   complex(ki), public :: abb9n16
   complex(ki), public :: abb9n17
   complex(ki), public :: abb9n18
   complex(ki), public :: abb9n19
   complex(ki), public :: abb9n20
   complex(ki), public :: abb9n21
   complex(ki), public :: abb9n22
   complex(ki), public :: abb9n23
   complex(ki), public :: abb9n24
   complex(ki), public :: abb9n25
   complex(ki), public :: abb9n26
   complex(ki), public :: abb9n27
   complex(ki), public :: abb9n28
   complex(ki), public :: abb9n29
   complex(ki), public :: abb9n30
   complex(ki), public :: abb9n31
   complex(ki), public :: abb9n32
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   real(ki) :: t30
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k6
      t4 = t3*spak3k5*spbk2k1
      t30 = TR*TR
      t5 = t30*t4*spbk4k1
      t6 = es61*es345*t1
      t7 = t5/t6
      t8 = t2*spak2k6
      t9 = t8*spak3k5*spbk2k1
      t10 = t30*t9*spbk4k2
      t11 = t10/t6
      t12 = NC*NC*t6
      t5 = t5/t12
      t10 = t10/t12
      t13 = c1*i_
      t14 = t13*spak1k6
      t15 = t14*spak3k5*spbk2k1
      t1 = es61*es345*NC*t1
      t16 = t30*t15/t1*spbk4k1
      t17 = t13*spak2k6
      t18 = t17*spak3k5*spbk2k1
      t19 = t30*t18/t1*spbk4k2
      t20 = NC*c1*i_
      t21 = t20*spak1k6
      t22 = t21*spak3k5*spbk2k1
      t23 = t30*t22/t6*spbk4k1
      t24 = t20*spak2k6
      t25 = t24*spak3k5*spbk2k1
      t26 = t30*t25/t6*spbk4k2
      t27 = t10+t23+t26+t5-(t7+t19+t16+t11)
      abb9n1 = ((2.0_ki)*t27)
      t28 = t30*t3*spbk2k1
      abb9n2 = ((4.0_ki)*(t28/t12+t30*t21/t6*spbk2k1-(t30*t14/t1*spbk2k1+t28/t6)&
      &))
      t28 = t30*t3*spak3k4*spbk2k1*spbk4k1
      t29 = t30*t8*spak3k4*spbk2k1*spbk4k2
      abb9n3 = ((4.0_ki)*(t28/t6+t29/t6+t30*t14/t1*spak3k4*spbk2k1*spbk4k1+t30*t&
      &17/t1*spak3k4*spbk2k1*spbk4k2-(t30*t24/t6*spak3k4*spbk2k1*spbk4k2+t30*t21&
      &/t6*spak3k4*spbk2k1*spbk4k1+t29/t12+t28/t12)))
      abb9n4 = ((8.0_ki)*t27)
      abb9n5 = ((4.0_ki)*(t11+t16+t19+t7-(t5+t26+t23+t10)))
      t4 = t30*t4*spbk3k1
      t3 = t30*t3*spak4k5*spbk2k1*spbk4k1
      t5 = t30*t9*spbk3k2
      t7 = t30*t8*spak4k5*spbk2k1*spbk4k2
      abb9n6 = ((4.0_ki)*(t3/t6+t4/t6+t5/t6+t7/t6+t30*t15/t1*spbk3k1+t30*t18/t1*&
      &spbk3k2+t30*t14/t1*spak4k5*spbk2k1*spbk4k1+t30*t17/t1*spak4k5*spbk2k1*spb&
      &k4k2-(t30*t24/t6*spak4k5*spbk2k1*spbk4k2+t30*t21/t6*spak4k5*spbk2k1*spbk4&
      &k1+t30*t25/t6*spbk3k2+t30*t22/t6*spbk3k1+t7/t12+t5/t12+t4/t12+t3/t12)))
      t3 = t30*t8*spbk2k1
      abb9n7 = ((4.0_ki)*(t3/t12+t30*t24/t6*spbk2k1-(t30*t17/t1*spbk2k1+t3/t6)))
      t3 = t2*spak5k6
      t4 = t30*t3*spbk2k1
      t5 = t4/t6
      t4 = t4/t12
      t7 = t13*spak5k6
      t8 = t30/t1*t7*spbk2k1
      t9 = t20*spak5k6
      t10 = t30/t6*t9*spbk2k1
      abb9n8 = ((16.0_ki)*(t10+t4-(t8+t5)))
      abb9n9 = ((16.0_ki)*(t5+t8-(t4+t10)))
      t4 = t30*t2*spak2k5*spbk2k1
      t5 = t30*t3*spbk6k1
      abb9n10 = ((8.0_ki)*(t4/t6+t5/t6+t30/t1*t7*spbk6k1+t30*t13/t1*spak2k5*spbk&
      &2k1-(t30*t20/t6*spak2k5*spbk2k1+t30/t6*t9*spbk6k1+t5/t12+t4/t12)))
      t2 = t30*t2*spak1k5*spbk2k1
      t3 = t30*t3*spbk6k2
      abb9n11 = ((8.0_ki)*(t3/t12+t2/t6+t30/t6*t9*spbk6k2+t30*t13/t1*spak1k5*spb&
      &k2k1-(t30*t20/t6*spak1k5*spbk2k1+t30/t1*t7*spbk6k2+t3/t6+t2/t12)))
      rat2d9 = abb9n1
      rat2 = rat2 + rat2d9
      abb9n13 = -(abb9n3)
      abb9n14 = abb9n11
      abb9n15 = abb9n10
      abb9n16 = abb9n9
      abb9n17 = abb9n8
      abb9n18 = abb9n7
      abb9n19 = abb9n6
      abb9n20 = abb9n5
      abb9n21 = abb9n4
      abb9n22 = abb9n3
      abb9n23 = abb9n2
      abb9n24 = -(abb9n2)
      abb9n25 = -(abb9n4)
      abb9n26 = (-2.0_ki)*abb9n5
      abb9n27 = -(abb9n6)
      abb9n28 = -(abb9n7)
      abb9n29 = -(abb9n8)
      abb9n30 = -(abb9n9)
      abb9n31 = -(abb9n10)
      abb9n32 = -(abb9n11)
   end subroutine
end module p3_ud_emnebaruu_abbrevd9h0
