module     p3_ud_emnebaruu_d58h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p3_ud_emnebaruu/helicity0/d58h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d58
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd58h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t30 = dotproduct(k5, qshift)
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t4 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t31 = dotproduct(k2, qshift)
      t32 = dotproduct(k6, qshift)
      t6 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t7 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t8 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t33 = dotproduct(qshift, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb58n34+t30*abb58n31+t1*t3*abb58n20+t1*t31*abb58n23+t1&
         &*t32*abb58n24+t1*t33*abb58n35+t1*t4*abb58n21+t1*t6*abb58n25+t2*t3*abb5&
         &8n19+t2*t31*abb58n28+t2*t32*abb58n29+t2*t33*abb58n32+t2*t5*abb58n22+t3&
         &*t30*abb58n27+t30*t5*abb58n26+t7*t8*abb58n30+t5*t7*t8*abb58n37)
         return
      end if
      t9 = k5(iv1)
      t10 = spvak5k1(iv1)
      t11 = k2(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k2(iv1)
      t16 = spvak5k4(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak6k2(iv1)
      t19 = spvak6k4(iv1)
      t20 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb58n34+t9*abb58n31+t1*t11*abb58n23+t1*t12*abb58n24+t&
         &1*t13*abb58n36+t1*t18*abb58n20+t1*t19*abb58n21+t1*t20*abb58n25+t10*t3*&
         &abb58n20+t10*t31*abb58n23+t10*t32*abb58n24+t10*t33*abb58n35+t10*t4*abb&
         &58n21+t10*t6*abb58n25+t11*t2*abb58n28+t12*t2*abb58n29+t13*t2*abb58n33+&
         &t14*t8*abb58n30+t15*t7*abb58n30+t16*t3*abb58n19+t16*t31*abb58n28+t16*t&
         &32*abb58n29+t16*t33*abb58n32+t16*t5*abb58n22+t17*t2*abb58n22+t17*t30*a&
         &bb58n26+t18*t2*abb58n19+t18*t30*abb58n27+t3*t9*abb58n27+t5*t9*abb58n26&
         &+t14*t5*t8*abb58n37+t15*t5*t7*abb58n37+t17*t7*t8*abb58n37)
         return
      end if
      t30 = d(iv1,iv2)
      t3 = spvak5k1(iv2)
      t4 = spvak5k4(iv2)
      t6 = k2(iv2)
      t21 = spvak6k1(iv2)
      t22 = spvak6k2(iv2)
      t23 = k5(iv2)
      t24 = k6(iv2)
      t25 = qshift(iv2)
      t26 = spvak5k2(iv2)
      t27 = t14*t26
      t28 = spvak3k4(iv2)
      t29 = t15*t28
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t30*abb58n35+t2*t30*abb58n32)+t27*abb58n30+t2&
         &9*abb58n30+spvak6k4(iv2)*t10*abb58n21+spvak6k5(iv2)*t10*abb58n25+t10*t&
         &22*abb58n20+t10*t24*abb58n24+t10*t25*abb58n36+t10*t6*abb58n23+t11*t3*a&
         &bb58n23+t11*t4*abb58n28+t12*t3*abb58n24+t12*t4*abb58n29+t13*t3*abb58n3&
         &6+t13*t4*abb58n33+t16*t21*abb58n22+t16*t22*abb58n19+t16*t24*abb58n29+t&
         &16*t25*abb58n33+t16*t6*abb58n28+t17*t23*abb58n26+t17*t4*abb58n22+t18*t&
         &23*abb58n27+t18*t3*abb58n20+t18*t4*abb58n19+t19*t3*abb58n21+t20*t3*abb&
         &58n25+t21*t9*abb58n26+t22*t9*abb58n27+t27*t5*abb58n37+t29*t5*abb58n37+&
         &t14*t21*t8*abb58n37+t15*t21*t7*abb58n37+t17*t26*t7*abb58n37+t17*t28*t8&
         &*abb58n37)
         return
      end if
      t31 = d(iv2,iv3)
      t32 = d(iv1,iv3)
      t1 = spvak6k1(iv3)
      t2 = spvak5k2(iv3)
      t5 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak5k1(iv3)*t30*abb58n35+spvak5k4(iv3)*t30*abb&
         &58n32+t10*t31*abb58n35+t16*t31*abb58n32+t3*t32*abb58n35+t32*t4*abb58n3&
         &2)+t1*t27*abb58n37+t1*t29*abb58n37+t14*t2*t21*abb58n37+t15*t21*t5*abb5&
         &8n37+t17*t2*t28*abb58n37+t17*t26*t5*abb58n37)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d58:
   subroutine     reconstruct_d58(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_58:
      coeffs%coeffs_58%c0 = derivative(czip)
      coeffs%coeffs_58%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_58%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_58%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_58%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_58%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_58%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_58%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_58%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_58%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_58%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_58%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_58%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_58%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_58%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_58%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_58%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_58%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_58%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_58%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_58%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_58%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_58%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_58%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_58%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_58%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_58%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_58%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_58%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_58:
   end subroutine reconstruct_d58
!---#] subroutine reconstruct_d58:
end module p3_ud_emnebaruu_d58h0l1d
