module     p3_ud_emnebaruu_d62h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p3_ud_emnebaruu/helicity0/d62h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d62
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd62h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3+k6+k5+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t15 = dotproduct(k3, qshift)
      t16 = dotproduct(k4, qshift)
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t17 = dotproduct(k2, qshift)
      if(deg.eq.0) then
         numerator = (abb62n15*(spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spva&
         &k6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb62n27*dotproduct(qshift, q&
         &shift)+abb62n30*(spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(&
         &3)*qshift(3)-spvak5k2(4)*qshift(4))+abb62n31*(spvak5k4(1)*qshift(1)-sp&
         &vak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb62&
         &n32*(spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)&
         &-spvak6k2(4)*qshift(4))+abb62n34*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qs&
         &hift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb62n35*(spvak6k&
         &1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)&
         &*qshift(4))+t1*t15*abb62n17+t1*t16*abb62n17+t1*t17*abb62n20+t1*t2*abb6&
         &2n16+t1*t4*abb62n23+t2*t3*abb62n18+t4*t5*abb62n19)
         return
      end if
      t6 = k2(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = spvak2k1(iv1)
      t10 = spvak3k1(iv1)
      t11 = t10*abb62n39
      t12 = spvak3k2(iv1)
      t13 = spvak3k4(iv1)
      t14 = spvak4k1(iv1)
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb62n29+spvak5k1(iv1)*abb62n22+spvak5k2(iv1)*&
         &abb62n26+spvak5k4(iv1)*abb62n25+spvak6k1(iv1)*abb62n21+spvak6k2(iv1)*a&
         &bb62n24+spvak6k4(iv1)*abb62n28+t11*t15+t11*t16+t1*t12*abb62n40+t1*t13*&
         &abb62n33+t1*t6*abb62n36+t1*t7*abb62n39+t1*t8*abb62n39+t10*t17*abb62n36&
         &+t10*t2*abb62n40+t10*t4*abb62n33+t12*t3*abb62n38+t13*t5*abb62n37+t14*t&
         &4*abb62n37+t2*t9*abb62n38)
         return
      end if
      t1 = spvak3k1(iv2)
      t2 = spvak3k2(iv2)
      t3 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb62n27+k2(iv2)*t10*abb62n20+k3(iv2)*&
         &t10*abb62n17+k4(iv2)*t10*abb62n17+spvak2k1(iv2)*t12*abb62n18+spvak4k1(&
         &iv2)*t13*abb62n19+t1*t12*abb62n16+t1*t13*abb62n23+t1*t6*abb62n20+t1*t7&
         &*abb62n17+t1*t8*abb62n17+t10*t2*abb62n16+t10*t3*abb62n23+t14*t3*abb62n&
         &19+t2*t9*abb62n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d62:
   subroutine     reconstruct_d62(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_62:
      coeffs%coeffs_62%c0 = derivative(czip)
      coeffs%coeffs_62%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_62%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_62%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_62%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_62%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_62%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_62%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_62%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_62%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_62%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_62%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_62%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_62%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_62%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_62:
   end subroutine reconstruct_d62
!---#] subroutine reconstruct_d62:
end module p3_ud_emnebaruu_d62h0l1d
