module     p7_dubar_emnebargg_abbrevd10h0
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh0
   implicit none
   private
   complex(ki), public :: abb10n1
   complex(ki), public :: abb10n2
   complex(ki), public :: abb10n3
   complex(ki), public :: abb10n4
   complex(ki), public :: abb10n5
   complex(ki), public :: abb10n6
   complex(ki), public :: abb10n7
   complex(ki), public :: abb10n8
   complex(ki), public :: abb10n9
   complex(ki), public :: abb10n10
   complex(ki), public :: abb10n11
   complex(ki), public :: abb10n12
   complex(ki), public :: abb10n13
   complex(ki), public :: abb10n14
   complex(ki), public :: abb10n15
   complex(ki), public :: abb10n16
   complex(ki), public :: abb10n17
   complex(ki), public :: rat2d10
   complex(ki), public :: abb10n19
   complex(ki), public :: abb10n20
   complex(ki), public :: abb10n21
   complex(ki), public :: abb10n22
   complex(ki), public :: abb10n23
   complex(ki), public :: abb10n24
   complex(ki), public :: abb10n25
   complex(ki), public :: abb10n26
   complex(ki), public :: abb10n27
   complex(ki), public :: abb10n28
   complex(ki), public :: abb10n29
   complex(ki), public :: abb10n30
   complex(ki), public :: abb10n31
   complex(ki), public :: abb10n32
   complex(ki), public :: abb10n33
   complex(ki), public :: abb10n34
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = TR*c2
      t2 = t1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k5*spbk5k1
      t5 = (es345-(es61+es12))*(es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = NC*t5
      t7 = t6*spak5k6
      t8 = t4/t7*spbk5k4*spbk6k2
      t9 = NC*TR*c2
      t10 = t9*i_
      t11 = t10*spak2k3
      t12 = t11*spak2k5*spbk5k1
      t13 = t5*spak5k6
      t14 = t12/t13*spbk5k4*spbk6k2
      t15 = t2*spak1k6
      t16 = t15*spak2k3
      t17 = t16*spak2k5
      t18 = spak5k6*spak5k6
      t6 = t18*t6
      t19 = t17/t6*spbk4k1*spbk5k1*spbk6k2
      t20 = t10*spak1k6
      t21 = t20*spak2k3
      t22 = t21*spak2k5
      t5 = t18*t5
      t18 = t22/t5*spbk4k1*spbk5k1*spbk6k2
      abb10n1 = ((2.0_ki)*(t14+t18-(t8+t19)))
      t23 = es12*t1*i_
      t24 = t23*spak2k5
      t25 = t24/t6*spbk5k1
      t26 = es345*t1*i_
      t27 = t26*spak2k5
      t28 = t27/t6*spbk5k1
      t29 = es61*t1*i_
      t30 = t29*spak2k5
      t31 = t30/t6*spbk5k1
      t32 = es12*t9*i_
      t33 = t32*spak2k5
      t34 = t33/t5*spbk5k1
      t35 = es345*t9*i_
      t36 = t35*spak2k5
      t37 = t36/t5*spbk5k1
      t38 = es61*t9*i_
      t39 = t38*spak2k5
      t40 = t39/t5*spbk5k1
      abb10n2 = ((16.0_ki)*(t25+t31+t37-(t40+t34+t28)))
      abb10n3 = ((16.0_ki)*(t28+t34+t40-(t37+t31+t25)))
      t25 = t2*spak1k2
      t28 = t25*spak2k5
      t31 = t10*spak1k2
      t34 = t31*spak2k5
      abb10n4 = ((8.0_ki)*(t34/t5*spbk5k1*spbk6k2-t28/t6*spbk5k1*spbk6k2))
      t37 = es234*t1*i_
      t40 = t37*spak2k3*spak2k5
      t41 = es34*t1*i_
      t42 = t26*spak2k3*spak2k5
      t1 = es56*t1*i_
      t43 = spak2k5*spak2k5
      t44 = t29*spak1k2
      t45 = t29*spak2k3*spak2k5
      t46 = es234*t9*i_
      t47 = t46*spak2k3*spak2k5
      t48 = es34*t9*i_
      t49 = t35*spak2k3*spak2k5
      t9 = es56*t9*i_
      t50 = t38*spak1k2
      t51 = t38*spak2k3*spak2k5
      abb10n5 = ((4.0_ki)*(t51/t13*spbk5k1*spbk5k4*spbk6k2+t40/t7*spbk5k1*spbk5k&
      &4*spbk6k2+t42/t7*spbk5k1*spbk5k4*spbk6k2+t44/t7*spak2k3*spbk4k1*spbk5k1*s&
      &pbk6k2+t35/t13*spak1k2*spak2k3*spbk4k1*spbk5k1*spbk6k2+t46/t13*spak1k2*sp&
      &ak2k3*spbk4k1*spbk5k1*spbk6k2+t48/t13*spak2k3*spak2k5*spbk5k1*spbk5k4*spb&
      &k6k2+t16*t43/t6*spbk2k1*spbk5k1*spbk5k4*spbk6k2+t38*t43/t5*spak3k6*spbk5k&
      &1*spbk5k4*spbk6k2+t41/t7*spak1k2*spak2k3*spbk4k1*spbk5k1*spbk6k2+t43/t5*t&
      &9*spak3k6*spbk5k1*spbk5k4*spbk6k2+t44/t6*spak2k5*spak3k6*spbk4k1*spbk5k1*&
      &spbk6k2+t1/t6*spak1k2*spak2k5*spak3k6*spbk4k1*spbk5k1*spbk6k2+t32/t5*spak&
      &1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2-(t9/t5*spak1k2*spak2k5*spak3k&
      &6*spbk4k1*spbk5k1*spbk6k2+t23/t6*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*&
      &spbk6k2+t50/t5*spak2k5*spak3k6*spbk4k1*spbk5k1*spbk6k2+t41/t7*spak2k3*spa&
      &k2k5*spbk5k1*spbk5k4*spbk6k2+t37/t7*spak1k2*spak2k3*spbk4k1*spbk5k1*spbk6&
      &k2+t29*t43/t6*spak3k6*spbk5k1*spbk5k4*spbk6k2+t26/t7*spak1k2*spak2k3*spbk&
      &4k1*spbk5k1*spbk6k2+t21*t43/t5*spbk2k1*spbk5k1*spbk5k4*spbk6k2+t48/t13*sp&
      &ak1k2*spak2k3*spbk4k1*spbk5k1*spbk6k2+t1*t43/t6*spak3k6*spbk5k1*spbk5k4*s&
      &pbk6k2+t50/t13*spak2k3*spbk4k1*spbk5k1*spbk6k2+t45/t7*spbk5k1*spbk5k4*spb&
      &k6k2+t49/t13*spbk5k1*spbk5k4*spbk6k2+t47/t13*spbk5k1*spbk5k4*spbk6k2)))
      t16 = spbk5k1*spbk5k1
      t21 = spak2k5*spbk5k1
      t21 = t21*t21
      abb10n6 = ((4.0_ki)*(t16/t13*t34*spbk6k2+t20*t21/t5*spbk6k2-(t16*t28/t7*sp&
      &bk6k2+t15*t21/t6*spbk6k2)))
      t21 = t2*spak1k3
      t37 = t10*spak1k3
      t15 = t15*spak2k5
      t20 = t20*spak2k5
      abb10n7 = ((4.0_ki)*(t15*t16/t6*spak3k5*spbk6k2+t16*t21/t7*spak2k5*spbk6k2&
      &-(t16*t20/t5*spak3k5*spbk6k2+t16/t13*t37*spak2k5*spbk6k2)))
      t1 = t1*spak2k3*spak2k5
      t9 = t9*spak2k3*spak2k5
      abb10n8 = ((4.0_ki)*(t1/t6*spbk5k4*spbk6k2+t45/t6*spbk5k4*spbk6k2+t47/t5*s&
      &pbk5k4*spbk6k2+t22/t5*spbk5k1*spbk6k2*spbk6k4+t23/t6*spak1k3*spak2k5*spbk&
      &5k1*spbk6k4+t29/t6*spak1k3*spak2k5*spbk5k1*spbk6k4+t35/t5*spak1k3*spak2k5&
      &*spbk5k1*spbk6k4+t37*t43/t5*spbk5k1*spbk5k4*spbk6k2+t25/t6*spak1k3*spak2k&
      &5*spbk4k1*spbk5k1*spbk6k2+t31/t5*spak2k3*spak2k5*spbk4k2*spbk5k1*spbk6k2-&
      &(t31/t5*spak1k3*spak2k5*spbk4k1*spbk5k1*spbk6k2+t25/t6*spak2k3*spak2k5*sp&
      &bk4k2*spbk5k1*spbk6k2+t38/t5*spak1k3*spak2k5*spbk5k1*spbk6k4+t32/t5*spak1&
      &k3*spak2k5*spbk5k1*spbk6k4+t26/t6*spak1k3*spak2k5*spbk5k1*spbk6k4+t21*t43&
      &/t6*spbk5k1*spbk5k4*spbk6k2+t17/t6*spbk5k1*spbk6k2*spbk6k4+t9/t5*spbk5k4*&
      &spbk6k2+t51/t5*spbk5k4*spbk6k2+t40/t6*spbk5k4*spbk6k2)))
      abb10n9 = ((4.0_ki)*(t15/t6*spbk5k1*spbk6k2-t20/t5*spbk5k1*spbk6k2))
      t8 = t19+t8-(t18+t14)
      abb10n10 = ((8.0_ki)*t8)
      abb10n11 = ((4.0_ki)*t8)
      abb10n12 = ((4.0_ki)*(t1/t6*spbk4k1*spbk6k2+t4/t7*spbk6k2*spbk6k4+t45/t6*s&
      &pbk4k1*spbk6k2+t47/t5*spbk4k1*spbk6k2+t24/t6*spak3k5*spbk5k1*spbk6k4+t30/&
      &t6*spak3k5*spbk5k1*spbk6k4+t36/t5*spak3k5*spbk5k1*spbk6k4+t11*t43/t5*spbk&
      &4k2*spbk5k1*spbk6k2+t28/t6*spak3k5*spbk4k1*spbk5k1*spbk6k2+t10*t43/t5*spa&
      &k3k5*spbk5k1*spbk5k4*spbk6k2-(t2*t43/t6*spak3k5*spbk5k1*spbk5k4*spbk6k2+t&
      &34/t5*spak3k5*spbk4k1*spbk5k1*spbk6k2+t3*t43/t6*spbk4k2*spbk5k1*spbk6k2+t&
      &39/t5*spak3k5*spbk5k1*spbk6k4+t33/t5*spak3k5*spbk5k1*spbk6k4+t27/t6*spak3&
      &k5*spbk5k1*spbk6k4+t9/t5*spbk4k1*spbk6k2+t51/t5*spbk4k1*spbk6k2+t40/t6*sp&
      &bk4k1*spbk6k2+t12/t13*spbk6k2*spbk6k4)))
      t1 = t23/t6*spak2k3*spak2k5*spbk4k2*spbk5k1
      t3 = t24/t6*spak3k6*spbk5k1*spbk6k4
      t4 = t42/t6*spbk4k2*spbk5k1
      t8 = t27/t6*spak3k6*spbk5k1*spbk6k4
      t9 = t45/t6*spbk4k2*spbk5k1
      t11 = t30/t6*spak3k6*spbk5k1*spbk6k4
      t12 = t2*t43/t6*spak3k6*spbk5k1*spbk5k4*spbk6k2
      t14 = t32/t5*spak2k3*spak2k5*spbk4k2*spbk5k1
      t16 = t33/t5*spak3k6*spbk5k1*spbk6k4
      t17 = t49/t5*spbk4k2*spbk5k1
      t18 = t36/t5*spak3k6*spbk5k1*spbk6k4
      t19 = t51/t5*spbk4k2*spbk5k1
      t21 = t39/t5*spak3k6*spbk5k1*spbk6k4
      t22 = t10*t43/t5*spak3k6*spbk5k1*spbk5k4*spbk6k2
      t23 = t28/t6*spak3k6*spbk4k1*spbk5k1*spbk6k2
      t24 = t34/t5*spak3k6*spbk4k1*spbk5k1*spbk6k2
      abb10n13 = ((8.0_ki)*(t1+t12+t16+t17+t21+t24+t8+t9-(t4+t3+t23+t22+t19+t18+&
      &t14+t11)))
      abb10n14 = ((8.0_ki)*(t11+t14+t18+t19+t22+t23+t3+t4-(t9+t8+t24+t21+t17+t16&
      &+t12+t1)))
      abb10n15 = ((8.0_ki)*(t10*t43/t5*spbk5k1*spbk6k2-t2*t43/t6*spbk5k1*spbk6k2&
      &))
      t1 = t2*spak2k5
      t2 = t10*spak2k5
      abb10n16 = ((4.0_ki)*(t1/t7*spak3k6*spbk5k1*spbk5k4*spbk6k2+t15/t6*spak3k6&
      &*spbk4k1*spbk5k1*spbk6k2-(t20/t5*spak3k6*spbk4k1*spbk5k1*spbk6k2+t2/t13*s&
      &pak3k6*spbk5k1*spbk5k4*spbk6k2)))
      abb10n17 = ((4.0_ki)*(t2/t13*spbk5k1*spbk6k2-t1/t7*spbk5k1*spbk6k2))
      rat2d10 = abb10n1
      rat2 = rat2 + rat2d10
      abb10n19 = abb10n5
      abb10n20 = abb10n17
      abb10n21 = abb10n15
      abb10n22 = abb10n11
      abb10n23 = abb10n9
      abb10n24 = abb10n4
      abb10n25 = abb10n3
      abb10n26 = abb10n2
      abb10n27 = -(abb10n6)
      abb10n28 = -(abb10n7)
      abb10n29 = -(abb10n8)
      abb10n30 = -(abb10n10)
      abb10n31 = -(abb10n12)
      abb10n32 = -(abb10n13)
      abb10n33 = -(abb10n14)
      abb10n34 = -(abb10n16)
   end subroutine
end module p7_dubar_emnebargg_abbrevd10h0
