module     p7_dubar_emnebargg_d89h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d89h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d89
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd89h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      real(ki) :: t80
      real(ki) :: t81
      real(ki) :: t82
      real(ki) :: t83
      real(ki) :: t84
      real(ki) :: t85
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k2(iv1)
      t2 = k6(iv1)
      t3 = spvak2k1(iv1)
      t4 = spvak2k5(iv1)
      t5 = spvak3k1(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb89n120+t2*abb89n125+t3*abb89n117+t4*abb89n122+t5*abb&
         &89n123+t6*abb89n124+t7*abb89n64)
         return
      end if
      t80 = d(iv1,iv2)
      t8 = k5(iv2)
      t9 = spvak5k6(iv2)
      t10 = t1*t9
      t11 = spvak6k5(iv2)
      t12 = k2(iv2)
      t13 = k5(iv1)
      t14 = t12*t7
      t15 = spvak6k5(iv1)
      t16 = spvak2k1(iv2)
      t17 = spvak2k5(iv2)
      t18 = t13*t17
      t19 = spvak3k1(iv2)
      t20 = t13*t19
      t21 = spvak3k4(iv2)
      t22 = t13*t21
      t23 = t4*t8
      t24 = t5*t8
      t25 = t6*t8
      t26 = t19*t2
      t27 = spvak5k1(iv2)
      t28 = t2*t27
      t29 = k6(iv2)
      t30 = t29*t5
      t31 = spvak5k1(iv1)
      t32 = t29*t31
      t33 = t3*t9
      t34 = t16*t7
      t35 = t21*t4
      t36 = t4*t9
      t37 = t17*t6
      t38 = t17*t7
      t39 = spvak2k6(iv1)
      t40 = t11*t39
      t41 = spvak2k6(iv2)
      t42 = t15*t41
      t43 = t5*t9
      t44 = t11*t5
      t45 = t19*t7
      t46 = t15*t19
      t47 = t27*t6
      t48 = spvak6k1(iv2)
      t49 = t48*t6
      t50 = t21*t31
      t51 = spvak6k1(iv1)
      t52 = t21*t51
      t53 = t48*t7
      t54 = t11*t7
      t55 = t51*t9
      t56 = t15*t9
      if(deg.eq.2) then
         numerator = (t10*abb89n91+t14*abb89n91+t18*abb89n100+t20*abb89n105+t22*&
         &abb89n107+t23*abb89n100+t24*abb89n105+t25*abb89n107+t26*abb89n114+t28*&
         &abb89n116+t30*abb89n114+t32*abb89n116+t33*abb89n79+t34*abb89n79+t35*ab&
         &b89n118+t36*abb89n101+t37*abb89n118+t38*abb89n101+t40*abb89n99+t42*abb&
         &89n99+t43*abb89n106+t44*abb89n102+t45*abb89n106+t46*abb89n102+t47*abb8&
         &9n112+t49*abb89n113+t50*abb89n112+t52*abb89n113+t53*abb89n115+t54*abb8&
         &9n110+t55*abb89n115+t56*abb89n110+(2.0_ki)*t80*abb89n119+t1*t11*abb89n&
         &84+t1*t8*abb89n87+t11*t13*abb89n111+t11*t2*abb89n111+t11*t3*abb89n76+t&
         &11*t6*abb89n103+t12*t13*abb89n87+t12*t15*abb89n84+t13*t16*abb89n78+t15&
         &*t16*abb89n76+t15*t21*abb89n103+t15*t29*abb89n111+t15*t8*abb89n111+t17&
         &*t2*abb89n121+t21*t7*abb89n109+t29*t4*abb89n121+t3*t8*abb89n78+t6*t9*a&
         &bb89n109)
         return
      end if
      t81 = d(iv2,iv3)
      t82 = d(iv1,iv3)
      t57 = k2(iv3)
      t58 = k5(iv3)
      t59 = spvak2k1(iv3)
      t60 = spvak2k5(iv3)
      t61 = spvak3k1(iv3)
      t62 = spvak3k4(iv3)
      t63 = spvak5k6(iv3)
      t64 = spvak6k5(iv3)
      t65 = spvak2k6(iv3)
      t66 = spvak5k1(iv3)
      t67 = spvak6k1(iv3)
      t68 = t13*t62
      t69 = t62*t8
      t70 = t58*t6
      t71 = t21*t58
      t72 = k6(iv3)
      t73 = spvak2k4(iv1)
      t74 = spvak2k4(iv2)
      t75 = spvak2k4(iv3)
      t76 = t4*t62
      t77 = t17*t62
      t78 = t6*t60
      t79 = t21*t60
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t81*abb89n89+t11*t82*abb89n85+t12*t82*abb89n8&
         &9+t13*t81*abb89n89+t15*t81*abb89n85+t16*t82*abb89n77+t17*t82*abb89n98+&
         &t19*t82*abb89n104+t21*t82*abb89n108+t3*t81*abb89n77+t4*t81*abb89n98+t5&
         &*t81*abb89n104+t57*t80*abb89n89+t58*t80*abb89n89+t59*t80*abb89n77+t6*t&
         &81*abb89n108+t60*t80*abb89n98+t61*t80*abb89n104+t62*t80*abb89n108+t63*&
         &t80*abb89n90+t64*t80*abb89n85+t7*t81*abb89n90+t8*t82*abb89n89+t82*t9*a&
         &bb89n90)+t10*t64*abb89n96+t14*t64*abb89n96+t18*t62*abb89n83+t20*t64*ab&
         &b89n72+t22*t66*abb89n66+t22*t67*abb89n70+t23*t62*abb89n83+t24*t64*abb8&
         &9n72+t25*t66*abb89n66+t25*t67*abb89n70+t26*t64*abb89n72+t27*t68*abb89n&
         &66+t27*t70*abb89n66+t28*t64*abb89n73+t30*t64*abb89n72+t31*t69*abb89n66&
         &+t31*t71*abb89n66+t32*t64*abb89n73+t33*t64*abb89n80+t34*t64*abb89n80+t&
         &35*t63*abb89n86+t36*t64*abb89n93+t37*t63*abb89n86+t38*t64*abb89n93+t43&
         &*t64*abb89n68+t45*t64*abb89n68+t48*t68*abb89n70+t48*t70*abb89n70+t51*t&
         &69*abb89n70+t51*t71*abb89n70+t53*t64*abb89n74+t55*t64*abb89n74+t7*t77*&
         &abb89n86+t7*t79*abb89n86+t76*t9*abb89n86+t78*t9*abb89n86+t1*t11*t63*ab&
         &b89n96+t11*t13*t61*abb89n72+t11*t13*t65*abb89n94+t11*t13*t66*abb89n73+&
         &t11*t2*t61*abb89n72+t11*t2*t65*abb89n94+t11*t2*t66*abb89n73+t11*t3*t63&
         &*abb89n80+t11*t31*t58*abb89n73+t11*t31*t63*abb89n75+t11*t31*t72*abb89n&
         &73+t11*t39*t58*abb89n94+t11*t39*t62*abb89n82+t11*t39*t63*abb89n92+t11*&
         &t39*t72*abb89n94+t11*t4*t63*abb89n93+t11*t5*t58*abb89n72+t11*t5*t63*ab&
         &b89n68+t11*t5*t72*abb89n72+t11*t51*t63*abb89n74+t11*t57*t7*abb89n96+t1&
         &1*t59*t7*abb89n80+t11*t6*t65*abb89n82+t11*t60*t7*abb89n93+t11*t61*t7*a&
         &bb89n68+t11*t63*t73*abb89n97+t11*t65*t7*abb89n92+t11*t66*t7*abb89n75+t&
         &11*t67*t7*abb89n74+t11*t7*t75*abb89n97+t12*t15*t63*abb89n96+t13*t21*t6&
         &0*abb89n83+t13*t27*t64*abb89n73+t13*t41*t64*abb89n94+t15*t16*t63*abb89&
         &n80+t15*t17*t63*abb89n93+t15*t19*t58*abb89n72+t15*t19*t63*abb89n68+t15&
         &*t19*t72*abb89n72+t15*t21*t65*abb89n82+t15*t27*t58*abb89n73+t15*t27*t6&
         &3*abb89n75+t15*t27*t72*abb89n73+t15*t29*t61*abb89n72+t15*t29*t65*abb89&
         &n94+t15*t29*t66*abb89n73+t15*t41*t58*abb89n94+t15*t41*t62*abb89n82+t15&
         &*t41*t63*abb89n92+t15*t41*t72*abb89n94+t15*t48*t63*abb89n74+t15*t57*t9&
         &*abb89n96+t15*t59*t9*abb89n80+t15*t60*t9*abb89n93+t15*t61*t8*abb89n72+&
         &t15*t61*t9*abb89n68+t15*t63*t74*abb89n97+t15*t65*t8*abb89n94+t15*t65*t&
         &9*abb89n92+t15*t66*t8*abb89n73+t15*t66*t9*abb89n75+t15*t67*t9*abb89n74&
         &+t15*t75*t9*abb89n97+t17*t58*t6*abb89n83+t2*t41*t64*abb89n94+t21*t39*t&
         &64*abb89n82+t21*t4*t58*abb89n83+t27*t64*t7*abb89n75+t29*t39*t64*abb89n&
         &94+t31*t64*t8*abb89n73+t31*t64*t9*abb89n75+t39*t64*t8*abb89n94+t39*t64&
         &*t9*abb89n92+t41*t6*t64*abb89n82+t41*t64*t7*abb89n92+t6*t60*t8*abb89n8&
         &3+t64*t7*t74*abb89n97+t64*t73*t9*abb89n97)
         return
      end if
      t83 = d(iv3,iv4)
      t84 = d(iv2,iv4)
      t85 = d(iv1,iv4)
      t1 = spvak3k4(iv4)
      t2 = spvak2k5(iv4)
      t8 = spvak6k5(iv4)
      t10 = spvak2k6(iv4)
      t12 = spvak3k1(iv4)
      t13 = spvak5k1(iv4)
      t14 = spvak6k1(iv4)
      t18 = spvak5k6(iv4)
      t20 = t21*t3
      t22 = t3*t62
      t3 = t1*t3
      t23 = t16*t6
      t24 = t16*t62
      t16 = t1*t16
      t25 = t59*t6
      t26 = t21*t59
      t28 = t1*t59
      t29 = spvak2k1(iv4)
      t30 = t29*t6
      t32 = t21*t29
      t29 = t29*t62
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t80*t83*abb89n88+t81*t85*abb89n88+t82*t84*abb89n&
         &88)+(2.0_ki)*(t35*t83*abb89n81+t37*t83*abb89n81+t40*t83*abb89n93+t42*t&
         &83*abb89n93+t44*t83*abb89n71+t46*t83*abb89n71+t47*t83*abb89n67+t49*t83&
         &*abb89n69+t50*t83*abb89n67+t52*t83*abb89n69+t54*t83*abb89n95+t56*t83*a&
         &bb89n95+t76*t84*abb89n81+t77*t85*abb89n81+t78*t84*abb89n81+t79*t85*abb&
         &89n81+t1*t17*t82*abb89n81+t1*t27*t82*abb89n67+t1*t31*t81*abb89n67+t1*t&
         &4*t81*abb89n81+t1*t48*t82*abb89n69+t1*t51*t81*abb89n69+t1*t60*t80*abb8&
         &9n81+t1*t66*t80*abb89n67+t1*t67*t80*abb89n69+t10*t11*t82*abb89n93+t10*&
         &t15*t81*abb89n93+t10*t64*t80*abb89n93+t11*t12*t82*abb89n71+t11*t13*t82&
         &*abb89n74+t11*t18*t82*abb89n95+t11*t31*t83*abb89n74+t11*t61*t85*abb89n&
         &71+t11*t63*t85*abb89n95+t11*t65*t85*abb89n93+t11*t66*t85*abb89n74+t12*&
         &t15*t81*abb89n71+t12*t64*t80*abb89n71+t13*t15*t81*abb89n74+t13*t21*t82&
         &*abb89n67+t13*t6*t81*abb89n67+t13*t62*t80*abb89n67+t13*t64*t80*abb89n7&
         &4+t14*t21*t82*abb89n69+t14*t6*t81*abb89n69+t14*t62*t80*abb89n69+t15*t1&
         &8*t81*abb89n95+t15*t27*t83*abb89n74+t15*t61*t84*abb89n71+t15*t63*t84*a&
         &bb89n95+t15*t65*t84*abb89n93+t15*t66*t84*abb89n74+t18*t64*t80*abb89n95&
         &+t19*t64*t85*abb89n71+t19*t8*t82*abb89n71+t2*t21*t82*abb89n81+t2*t6*t8&
         &1*abb89n81+t2*t62*t80*abb89n81+t21*t66*t85*abb89n67+t21*t67*t85*abb89n&
         &69+t27*t62*t85*abb89n67+t27*t64*t85*abb89n74+t27*t8*t82*abb89n74+t31*t&
         &62*t84*abb89n67+t31*t64*t84*abb89n74+t31*t8*t81*abb89n74+t39*t64*t84*a&
         &bb89n93+t39*t8*t81*abb89n93+t41*t64*t85*abb89n93+t41*t8*t82*abb89n93+t&
         &48*t62*t85*abb89n69+t5*t64*t84*abb89n71+t5*t8*t81*abb89n71+t51*t62*t84&
         &*abb89n69+t6*t66*t84*abb89n67+t6*t67*t84*abb89n69+t61*t8*t80*abb89n71+&
         &t63*t8*t80*abb89n95+t64*t7*t84*abb89n95+t64*t85*t9*abb89n95+t65*t8*t80&
         &*abb89n93+t66*t8*t80*abb89n74+t7*t8*t81*abb89n95+t8*t82*t9*abb89n95)+t&
         &11*t18*t22*abb89n65+t11*t18*t25*abb89n65+t11*t28*t7*abb89n65+t11*t29*t&
         &7*abb89n65+t11*t3*t63*abb89n65+t11*t30*t63*abb89n65+t15*t16*t63*abb89n&
         &65+t15*t18*t24*abb89n65+t15*t18*t26*abb89n65+t15*t28*t9*abb89n65+t15*t&
         &29*t9*abb89n65+t15*t32*t63*abb89n65+t16*t64*t7*abb89n65+t18*t20*t64*ab&
         &b89n65+t18*t23*t64*abb89n65+t20*t63*t8*abb89n65+t22*t8*t9*abb89n65+t23&
         &*t63*t8*abb89n65+t24*t7*t8*abb89n65+t25*t8*t9*abb89n65+t26*t7*t8*abb89&
         &n65+t3*t64*t9*abb89n65+t30*t64*t9*abb89n65+t32*t64*t7*abb89n65)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d89:
   subroutine     reconstruct_d89(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_89:
      coeffs%coeffs_89%c0 = derivative(czip)
      coeffs%coeffs_89%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_89%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_89%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_89%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_89%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_89%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_89%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_89%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_89%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_89%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_89%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_89%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_89%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_89%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_89%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_89%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_89%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_89%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_89%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_89%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_89%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_89%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_89%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_89%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_89%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_89%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_89%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_89%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_89%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_89%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_89%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_89:
   end subroutine reconstruct_d89
!---#] subroutine reconstruct_d89:
end module p7_dubar_emnebargg_d89h0l1d
