module     p7_dubar_emnebargg_abbrevd101h1
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh1
   implicit none
   private
   complex(ki), public :: abb101n1
   complex(ki), public :: abb101n2
   complex(ki), public :: abb101n3
   complex(ki), public :: abb101n4
   complex(ki), public :: abb101n5
   complex(ki), public :: abb101n6
   complex(ki), public :: abb101n7
   complex(ki), public :: abb101n8
   complex(ki), public :: abb101n9
   complex(ki), public :: abb101n10
   complex(ki), public :: abb101n11
   complex(ki), public :: abb101n12
   complex(ki), public :: abb101n13
   complex(ki), public :: rat2d101
   complex(ki), public :: abb101n15
   complex(ki), public :: abb101n16
   complex(ki), public :: abb101n17
   complex(ki), public :: abb101n18
   complex(ki), public :: abb101n19
   complex(ki), public :: abb101n20
   complex(ki), public :: abb101n21
   complex(ki), public :: abb101n22
   complex(ki), public :: abb101n23
   complex(ki), public :: abb101n24
   complex(ki), public :: abb101n25
   complex(ki), public :: abb101n26
   complex(ki), public :: abb101n27
   complex(ki), public :: abb101n28
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c3
      t3 = es56*t2*i_
      t4 = t3*spak1k5*spak2k3
      t5 = spbk6k1*spbk6k1
      t6 = es234*t1
      t7 = t6*spak5k6
      t8 = t7*spbk6k5
      t9 = t2*i_
      t10 = t9*spak1k5*spak2k3
      t11 = t10*spak2k5*spbk4k2
      t12 = t11*t5
      t1 = t1*spak5k6*spbk6k5
      t13 = t10*spak3k5*spbk4k3
      t14 = t13*t5
      t2 = es61*t2*i_*spak1k5*spak2k3
      abb101n1 = ((4.0_ki)*(t4*t5/t8*spak2k5*spbk4k2-t4*t5/t8*spak3k5*spbk4k3)+(&
      &2.0_ki)*(t14/t1+t2*t5/t8*spak2k5*spbk4k2-(t2*t5/t8*spak3k5*spbk4k3+t12/t1&
      &)))
      t1 = t12/t8
      t2 = t14/t8
      abb101n2 = ((8.0_ki)*(t2-t1))
      t1 = t1-t2
      abb101n3 = ((4.0_ki)*t1)
      abb101n4 = ((8.0_ki)*t1)
      t1 = t9*spak1k2
      t2 = t1*spak2k3*spbk4k2
      t4 = t6*spbk6k5
      t6 = t9*spak1k3
      t12 = t6*spak2k3*spbk4k3
      t3 = t3*spak2k3
      abb101n5 = ((4.0_ki)*(t2/t4*t5-t12/t4*t5)+(2.0_ki)*(t10*t5/t8*spak3k6*spbk&
      &4k3+t3/t8*spak3k5*spbk4k3*spbk6k1-(t3/t8*spak2k5*spbk4k2*spbk6k1+t10*t5/t&
      &8*spak2k6*spbk4k2)))
      abb101n6 = (-8.0_ki)*t10/t8*spbk4k2*spbk6k1
      abb101n7 = ((6.0_ki)*(t11/t7*spbk6k1-t13/t7*spbk6k1)+(2.0_ki)*(t5*t6/t8*sp&
      &ak1k5*spak2k3*spbk4k3-t1*t5/t8*spak1k5*spak2k3*spbk4k2))
      abb101n8 = ((8.0_ki)*t10/t8*spbk4k3*spbk6k1)
      t1 = t9*spak2k3
      abb101n9 = (-4.0_ki)*t1/t4*spbk4k2*spbk6k1
      t3 = t1*spak2k5*spbk4k2
      t5 = t1*spak3k5*spbk4k3
      t6 = t3/t8*spbk6k1-t5/t8*spbk6k1
      abb101n10 = ((4.0_ki)*t6)
      abb101n11 = ((16.0_ki)*t6)
      abb101n12 = ((4.0_ki)*t1/t4*spbk4k3*spbk6k1)
      abb101n13 = ((4.0_ki)*(t5/t7-t3/t7)+(12.0_ki)*(t2/t8*spbk6k1-t12/t8*spbk6k&
      &1))
      rat2d101 = 0
      rat2 = rat2 + rat2d101
      abb101n15 = abb101n1
      abb101n16 = abb101n13
      abb101n17 = abb101n12
      abb101n18 = abb101n11
      abb101n19 = abb101n10
      abb101n20 = abb101n9
      abb101n21 = abb101n8
      abb101n22 = abb101n6
      abb101n23 = abb101n4
      abb101n24 = -(abb101n2)
      abb101n25 = -(abb101n3)
      abb101n26 = ((2.0_ki)*abb101n4)
      abb101n27 = -(abb101n5)
      abb101n28 = -(abb101n7)
   end subroutine
end module p7_dubar_emnebargg_abbrevd101h1
