module     p7_dubar_emnebargg_d105h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d105h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d105
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd105h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      real(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t18 = dotproduct(qshift, qshift)
      t19 = dotproduct(k5, qshift)
      t3 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t20 = dotproduct(k1, qshift)
      t21 = dotproduct(k6, qshift)
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb105n16+t1*abb105n32+t18*abb105n28+t19*abb105n30+t2*abb1&
         &05n23+t1*t18*abb105n40+t1*t19*abb105n26+t1*t20*abb105n24+t1*t21*abb105&
         &n25+t1*t3*abb105n19+t1*t4*abb105n21+t1*t5*abb105n22+t2*t6*abb105n44+t2&
         &*t7*abb105n47)
         return
      end if
      t8 = k5(iv1)
      t9 = qshift(iv1)
      t10 = spvak5k6(iv1)
      t11 = k1(iv1)
      t12 = k6(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k6(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak3k6(iv1)
      t17 = spvak5k1(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb105n27+t8*abb105n29+t9*abb105n31+t1*t10*abb105n36+t&
         &1*t11*abb105n35+t1*t12*abb105n34+t1*t14*abb105n38+t1*t16*abb105n42+t1*&
         &t17*abb105n37+t1*t8*abb105n33+t1*t9*abb105n39+t10*t18*abb105n20+t10*t1&
         &9*abb105n33+t10*t20*abb105n35+t10*t21*abb105n34+t10*t3*abb105n42+t10*t&
         &4*abb105n38+t10*t5*abb105n37+t13*t2*abb105n18+t15*t2*abb105n17+t1*t10*&
         &t6*abb105n43+t1*t10*t7*abb105n46)
         return
      end if
      t18 = d(iv1,iv2)
      t2 = spvak5k6(iv2)
      t3 = t10*t2
      t4 = t13*t2
      t5 = spvak2k1(iv2)*t10
      t13 = t15*t2
      t15 = spvak3k1(iv2)*t10
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t18*abb105n28+t3*abb105n23+t1*t18*abb105n40+t3*t&
         &6*abb105n44+t3*t7*abb105n47)+k1(iv2)*t10*abb105n24+k5(iv2)*t10*abb105n&
         &26+k6(iv2)*t10*abb105n25+qshift(iv2)*t10*abb105n41+spvak2k6(iv2)*t10*a&
         &bb105n21+spvak3k6(iv2)*t10*abb105n19+spvak5k1(iv2)*t10*abb105n22+t1*t1&
         &3*abb105n48+t1*t15*abb105n48+t1*t4*abb105n45+t1*t5*abb105n45+t11*t2*ab&
         &b105n24+t12*t2*abb105n25+t14*t2*abb105n21+t16*t2*abb105n19+t17*t2*abb1&
         &05n22+t2*t8*abb105n26+t2*t9*abb105n41)
         return
      end if
      t1 = spvak5k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t2*abb105n20+d(iv2,iv3)*t10*abb105n20&
         &+t1*t13*abb105n17+t1*t15*abb105n17+t1*t18*abb105n20+t1*t4*abb105n18+t1&
         &*t5*abb105n18+spvak2k1(iv3)*t10*t2*abb105n18+spvak3k1(iv3)*t10*t2*abb1&
         &05n17))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d105:
   subroutine     reconstruct_d105(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_105:
      coeffs%coeffs_105%c0 = derivative(czip)
      coeffs%coeffs_105%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_105%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_105%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_105%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_105%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_105%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_105%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_105%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_105%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_105%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_105%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_105%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_105%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_105%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_105%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_105%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_105%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_105%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_105%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_105%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_105%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_105%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_105%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_105%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_105%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_105%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_105%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_105%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_105:
   end subroutine reconstruct_d105
!---#] subroutine reconstruct_d105:
end module p7_dubar_emnebargg_d105h1l1d
