module     p7_dubar_emnebargg_d24h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d24h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd24h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb24n39
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb24n67+t2*abb24n60+t3*abb24n68+t4*abb24n66+t5*abb24n5&
         &8+t6*abb24n64+t7*abb24n61)
         return
      end if
      t30 = d(iv1,iv2)
      t8 = k1(iv2)
      t9 = k6(iv2)
      t10 = spvak5k6(iv2)
      t11 = k5(iv2)
      t12 = spvak3k4(iv2)
      t13 = t1*t12
      t14 = spvak5k1(iv2)
      t15 = t5*t8
      t16 = k2(iv2)
      t17 = t12*t4
      t18 = t5*t9
      t19 = t14*t5
      t20 = t10*t5
      t21 = t12*t6
      t22 = t12*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t30*abb24n48+t1*t8*abb24n44+t10*t7*abb24n40+t4*t&
         &9*abb24n44)+t13*abb24n55+t15*abb24n55+t17*abb24n54+t18*abb24n54+t19*ab&
         &b24n49+t20*abb24n53+t21*abb24n49+t22*abb24n53+spvak2k4(iv1)*t10*abb24n&
         &52+spvak2k4(iv2)*t7*abb24n52+t1*t10*abb24n41+t1*t11*abb24n45+t1*t14*ab&
         &b24n56+t1*t9*abb24n46+t10*t2*abb24n47+t10*t3*abb24n43+t10*t4*abb24n42+&
         &t10*t6*abb24n51+t11*t4*abb24n44+t11*t5*abb24n55+t11*t6*abb24n57+t11*t7&
         &*abb24n43+t12*t3*abb24n55+t14*t2*abb24n50+t14*t3*abb24n57+t14*t4*abb24&
         &n57+t14*t7*abb24n51+t16*t6*abb24n50+t16*t7*abb24n47+t3*t8*abb24n45+t3*&
         &t9*abb24n44+t4*t8*abb24n46+t6*t8*abb24n56+t6*t9*abb24n57+t7*t8*abb24n4&
         &1+t7*t9*abb24n42)
         return
      end if
      t31 = d(iv2,iv3)
      t32 = d(iv1,iv3)
      t2 = k1(iv3)
      t3 = k6(iv3)
      t11 = spvak3k4(iv3)
      t16 = spvak5k1(iv3)
      t23 = spvak5k6(iv3)
      t24 = spvak2k1(iv1)
      t25 = spvak2k1(iv2)
      t26 = spvak2k1(iv3)
      t27 = spvak2k6(iv1)
      t28 = spvak2k6(iv2)
      t29 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t31*abb24n69+t10*t32*abb24n71+t11*t30*abb24n6&
         &2+t12*t32*abb24n62+t14*t32*abb24n63+t16*t30*abb24n63+t2*t30*abb24n69+t&
         &20*t23*abb24n74+t22*t23*abb24n74+t23*t30*abb24n71+t3*t30*abb24n70+t31*&
         &t4*abb24n70+t31*t5*abb24n62+t31*t6*abb24n63+t31*t7*abb24n71+t32*t8*abb&
         &24n69+t32*t9*abb24n70+t10*t11*t7*abb24n74)+t13*t23*abb24n73+t15*t23*ab&
         &b24n73+t17*t23*abb24n72+t18*t23*abb24n72+t19*t23*abb24n59+t21*t23*abb2&
         &4n59+t1*t10*t11*abb24n73+t10*t11*t24*abb24n65+t10*t11*t27*abb24n75+t10&
         &*t11*t4*abb24n72+t10*t11*t6*abb24n59+t10*t16*t5*abb24n59+t10*t2*t5*abb&
         &24n73+t10*t26*t5*abb24n65+t10*t29*t5*abb24n75+t10*t3*t5*abb24n72+t11*t&
         &14*t7*abb24n59+t11*t25*t7*abb24n65+t11*t28*t7*abb24n75+t11*t7*t8*abb24&
         &n73+t11*t7*t9*abb24n72+t12*t16*t7*abb24n59+t12*t2*t7*abb24n73+t12*t23*&
         &t24*abb24n65+t12*t23*t27*abb24n75+t12*t26*t7*abb24n65+t12*t29*t7*abb24&
         &n75+t12*t3*t7*abb24n72+t23*t25*t5*abb24n65+t23*t28*t5*abb24n75)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p7_dubar_emnebargg_d24h1l1d
