module     p7_dubar_emnebargg_d85h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d85h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d85
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd85h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      real(ki) :: t90
      real(ki) :: t91
      real(ki) :: t92
      real(ki) :: t93
      real(ki) :: t94
      real(ki) :: t95
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t3 = t1*t1
      t90 = dotproduct(k2, qshift)
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t91 = dotproduct(k1, qshift)
      t92 = dotproduct(qshift, qshift)
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t93 = dotproduct(k5, qshift)
      t94 = dotproduct(k6, qshift)
      t9 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*t2*abb85n25+t1*t4*abb85n29+t1*t5*abb85n30+t1*t90*abb85n&
         &28+t1*t92*abb85n38+t2*t3*abb85n22+t3*t4*abb85n46+t3*t5*abb85n48+t3*t6*&
         &abb85n43+t3*t7*abb85n53+t3*t90*abb85n34+t3*t91*abb85n36+t1*t5*t92*abb8&
         &5n31+t1*t5*t93*abb85n50+t1*t5*t94*abb85n50+t1*t6*t92*abb85n26+t1*t6*t9&
         &3*abb85n42+t1*t6*t94*abb85n42+t1*t7*t92*abb85n24+t1*t7*t93*abb85n51+t1&
         &*t7*t94*abb85n51+t1*t8*t9*abb85n45+t1*t8*t92*abb85n27+t3*t4*t8*abb85n2&
         &3)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k4(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k1(iv1)
      t19 = k5(iv1)
      t20 = k6(iv1)
      t21 = t14*abb85n42
      t22 = spvak2k6(iv1)
      t23 = t15*abb85n51
      t24 = spvak3k4(iv1)
      t25 = t16*abb85n50
      t26 = t17*abb85n42
      t27 = t17*abb85n50
      t28 = t17*abb85n51
      if(deg.eq.1) then
         numerator = (t1*t11*abb85n28+t1*t12*abb85n39+t1*t13*abb85n29+t1*t16*abb&
         &85n30+t1*t18*abb85n25+t1*t21*t93+t1*t21*t94+t1*t23*t93+t1*t23*t94+t1*t&
         &25*t93+t1*t25*t94+t10*t3*abb85n36+t11*t3*abb85n34+t13*t3*abb85n46+t14*&
         &t3*abb85n43+t15*t3*abb85n53+t16*t3*abb85n48+t17*t2*abb85n25+t17*t4*abb&
         &85n29+t17*t5*abb85n30+t17*t90*abb85n28+t17*t92*abb85n38+t18*t3*abb85n2&
         &2+t26*t6*t93+t26*t6*t94+t27*t5*t93+t27*t5*t94+t28*t7*t93+t28*t7*t94+t1&
         &*t12*t5*abb85n32+t1*t12*t6*abb85n41+t1*t12*t7*abb85n52+t1*t12*t8*abb85&
         &n40+t1*t14*t92*abb85n26+t1*t15*t92*abb85n24+t1*t16*t92*abb85n31+t1*t17&
         &*t2*abb85n33+t1*t17*t4*abb85n47+t1*t17*t5*abb85n49+t1*t17*t6*abb85n44+&
         &t1*t17*t7*abb85n54+t1*t17*t90*abb85n35+t1*t17*t91*abb85n37+t1*t19*t5*a&
         &bb85n50+t1*t19*t6*abb85n42+t1*t19*t7*abb85n51+t1*t20*t5*abb85n50+t1*t2&
         &0*t6*abb85n42+t1*t20*t7*abb85n51+t1*t22*t8*abb85n45+t1*t24*t9*abb85n45&
         &+t1*t24*t92*abb85n27+t13*t3*t8*abb85n23+t17*t5*t92*abb85n31+t17*t6*t92&
         &*abb85n26+t17*t7*t92*abb85n24+t17*t8*t9*abb85n45+t17*t8*t92*abb85n27+t&
         &24*t3*t4*abb85n23+t1*t17*t4*t8*abb85n55)
         return
      end if
      t95 = d(iv1,iv2)
      t21 = spvak5k6(iv2)
      t23 = t17*t21
      t11 = t11*t21
      t25 = k2(iv2)*t17
      t26 = t12*t21
      t27 = qshift(iv2)
      t28 = t17*t27
      t29 = t13*t21
      t30 = spvak2k1(iv2)
      t31 = t17*t30
      t32 = t16*t21
      t33 = spvak5k1(iv2)
      t34 = t17*t33
      t35 = spvak6k1(iv2)
      t36 = t17*t35
      t37 = t18*t21
      t10 = t10*t21
      t38 = k1(iv2)*t17
      t39 = spvak2k4(iv2)
      t40 = t19*t39
      t41 = spvak3k1(iv2)
      t42 = t19*t41
      t43 = t19*t33
      t44 = t19*t21
      t45 = k5(iv2)
      t46 = t14*t45
      t47 = t15*t45
      t48 = t16*t45
      t49 = t17*t45
      t50 = t20*t39
      t51 = t20*t41
      t52 = t20*t33
      t53 = t20*t21
      t54 = k6(iv2)
      t55 = t14*t54
      t56 = t15*t54
      t57 = t16*t54
      t58 = t17*t54
      t59 = t12*t39
      t60 = t12*t41
      t61 = spvak3k4(iv2)
      t62 = t12*t61
      t63 = t12*t33
      t64 = t14*t27
      t65 = t15*t27
      t66 = t24*t27
      t67 = t16*t27
      t68 = t13*t61
      t69 = t24*t30
      t70 = t14*t21
      t71 = t70*abb85n42
      t72 = t17*t39
      t73 = t72*abb85n42
      t74 = t22*t61
      t75 = spvak2k6(iv2)
      t76 = t24*t75
      t77 = t15*t21
      t78 = t77*abb85n51
      t79 = t17*t41
      t80 = t79*abb85n51
      t81 = t21*t24
      t82 = t17*t61
      t83 = t32*abb85n50
      t84 = t34*abb85n50
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t95*abb85n38+t2*t23*abb85n22+t23*t4*abb85n46+&
         &t23*t5*abb85n48+t23*t6*abb85n43+t23*t7*abb85n53+t23*t90*abb85n34+t23*t&
         &91*abb85n36+t1*t5*t95*abb85n31+t1*t6*t95*abb85n26+t1*t7*t95*abb85n24+t&
         &1*t8*t95*abb85n27+t23*t4*t8*abb85n23)+t11*abb85n28+t25*abb85n28+t26*ab&
         &b85n39+t28*abb85n39+t29*abb85n29+t31*abb85n29+t32*abb85n30+t34*abb85n3&
         &0+t36*abb85n25+t37*abb85n25+t71*t93+t71*t94+t73*t93+t73*t94+t78*t93+t7&
         &8*t94+t80*t93+t80*t94+t83*t93+t83*t94+t84*t93+t84*t94+t1*t10*abb85n37+&
         &t1*t11*abb85n35+t1*t25*abb85n35+t1*t29*abb85n47+t1*t31*abb85n47+t1*t32&
         &*abb85n49+t1*t34*abb85n49+t1*t36*abb85n33+t1*t37*abb85n33+t1*t38*abb85&
         &n37+t1*t40*abb85n42+t1*t42*abb85n51+t1*t43*abb85n50+t1*t46*abb85n42+t1&
         &*t47*abb85n51+t1*t48*abb85n50+t1*t50*abb85n42+t1*t51*abb85n51+t1*t52*a&
         &bb85n50+t1*t55*abb85n42+t1*t56*abb85n51+t1*t57*abb85n50+t1*t59*abb85n4&
         &1+t1*t60*abb85n52+t1*t62*abb85n40+t1*t63*abb85n32+t1*t64*abb85n41+t1*t&
         &65*abb85n52+t1*t66*abb85n40+t1*t67*abb85n32+t1*t70*abb85n44+t1*t72*abb&
         &85n44+t1*t74*abb85n45+t1*t76*abb85n45+t1*t77*abb85n54+t1*t79*abb85n54+&
         &t26*t5*abb85n32+t26*t6*abb85n41+t26*t7*abb85n52+t26*t8*abb85n40+t28*t5&
         &*abb85n32+t28*t6*abb85n41+t28*t7*abb85n52+t28*t8*abb85n40+t3*t68*abb85&
         &n23+t3*t69*abb85n23+t32*t92*abb85n31+t34*t92*abb85n31+t44*t5*abb85n50+&
         &t44*t6*abb85n42+t44*t7*abb85n51+t49*t5*abb85n50+t49*t6*abb85n42+t49*t7&
         &*abb85n51+t5*t53*abb85n50+t5*t58*abb85n50+t53*t6*abb85n42+t53*t7*abb85&
         &n51+t58*t6*abb85n42+t58*t7*abb85n51+t70*t92*abb85n26+t72*t92*abb85n26+&
         &t77*t92*abb85n24+t79*t92*abb85n24+t81*t9*abb85n45+t81*t92*abb85n27+t82&
         &*t9*abb85n45+t82*t92*abb85n27+t1*t29*t8*abb85n55+t1*t31*t8*abb85n55+t1&
         &*t4*t81*abb85n55+t1*t4*t82*abb85n55+t17*t75*t8*abb85n45+t21*t22*t8*abb&
         &85n45)
         return
      end if
      t90 = d(iv2,iv3)
      t2 = t17*t90
      t91 = d(iv1,iv3)
      t3 = t21*t91
      t9 = spvak5k6(iv3)
      t26 = t9*t95
      t28 = t29*t9
      t29 = t31*t9
      t31 = spvak2k1(iv3)
      t36 = t17*t21*t31
      t37 = spvak2k4(iv3)
      t44 = t17*t37
      t49 = spvak3k1(iv3)
      t53 = t17*t49
      t58 = spvak3k4(iv3)
      t71 = spvak5k1(iv3)
      t73 = t17*t71
      t78 = t17*t58
      t80 = k5(iv3)
      t83 = k6(iv3)
      t84 = qshift(iv3)
      t85 = spvak2k6(iv3)
      t68 = t68*t9
      t86 = t13*t21*t58
      t69 = t69*t9
      t87 = t17*t30*t58
      t88 = t21*t24*t31
      t89 = t17*t31*t61
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t2*abb85n38+t26*abb85n38+t28*abb85n46+t29*abb85n&
         &46+t3*abb85n38+t36*abb85n46+spvak6k1(iv3)*t23*abb85n22+t10*t9*abb85n36&
         &+t11*t9*abb85n34+t2*t5*abb85n31+t2*t6*abb85n26+t2*t7*abb85n24+t2*t8*ab&
         &b85n27+t21*t44*abb85n43+t21*t53*abb85n53+t21*t73*abb85n48+t25*t9*abb85&
         &n34+t26*t5*abb85n31+t26*t6*abb85n26+t26*t7*abb85n24+t26*t8*abb85n27+t2&
         &8*t8*abb85n23+t29*t8*abb85n23+t3*t5*abb85n31+t3*t6*abb85n26+t3*t7*abb8&
         &5n24+t3*t8*abb85n27+t32*t9*abb85n48+t34*t9*abb85n48+t36*t8*abb85n23+t3&
         &8*t9*abb85n36+t70*t9*abb85n43+t72*t9*abb85n43+t77*t9*abb85n53+t79*t9*a&
         &bb85n53+k1(iv3)*t17*t21*abb85n36+k2(iv3)*t17*t21*abb85n34+t1*t14*t90*a&
         &bb85n26+t1*t15*t90*abb85n24+t1*t16*t90*abb85n31+t1*t24*t90*abb85n27+t1&
         &*t33*t91*abb85n31+t1*t37*t95*abb85n26+t1*t39*t91*abb85n26+t1*t41*t91*a&
         &bb85n24+t1*t49*t95*abb85n24+t1*t58*t95*abb85n27+t1*t61*t91*abb85n27+t1&
         &*t71*t95*abb85n31+t17*t35*t9*abb85n22+t18*t21*t9*abb85n22+t21*t4*t78*a&
         &bb85n23+t4*t81*t9*abb85n23+t4*t82*t9*abb85n23)+t1*t68*abb85n55+t1*t69*&
         &abb85n55+t1*t86*abb85n55+t1*t87*abb85n55+t1*t88*abb85n55+t1*t89*abb85n&
         &55+t40*t9*abb85n42+t42*t9*abb85n51+t43*t9*abb85n50+t46*t9*abb85n42+t47&
         &*t9*abb85n51+t48*t9*abb85n50+t50*t9*abb85n42+t51*t9*abb85n51+t52*t9*ab&
         &b85n50+t55*t9*abb85n42+t56*t9*abb85n51+t57*t9*abb85n50+t59*t9*abb85n41&
         &+t60*t9*abb85n52+t62*t9*abb85n40+t63*t9*abb85n32+t64*t9*abb85n41+t65*t&
         &9*abb85n52+t66*t9*abb85n40+t67*t9*abb85n32+t74*t9*abb85n45+t76*t9*abb8&
         &5n45+t12*t21*t37*abb85n41+t12*t21*t49*abb85n52+t12*t21*t58*abb85n40+t1&
         &2*t21*t71*abb85n32+t14*t21*t80*abb85n42+t14*t21*t83*abb85n42+t14*t21*t&
         &84*abb85n41+t15*t21*t80*abb85n51+t15*t21*t83*abb85n51+t15*t21*t84*abb8&
         &5n52+t16*t21*t80*abb85n50+t16*t21*t83*abb85n50+t16*t21*t84*abb85n32+t1&
         &7*t27*t37*abb85n41+t17*t27*t49*abb85n52+t17*t27*t58*abb85n40+t17*t27*t&
         &71*abb85n32+t17*t33*t80*abb85n50+t17*t33*t83*abb85n50+t17*t33*t84*abb8&
         &5n32+t17*t37*t45*abb85n42+t17*t37*t54*abb85n42+t17*t39*t80*abb85n42+t1&
         &7*t39*t83*abb85n42+t17*t39*t84*abb85n41+t17*t41*t80*abb85n51+t17*t41*t&
         &83*abb85n51+t17*t41*t84*abb85n52+t17*t45*t49*abb85n51+t17*t45*t71*abb8&
         &5n50+t17*t49*t54*abb85n51+t17*t54*t71*abb85n50+t17*t58*t75*abb85n45+t1&
         &7*t61*t84*abb85n40+t17*t61*t85*abb85n45+t19*t21*t37*abb85n42+t19*t21*t&
         &49*abb85n51+t19*t21*t71*abb85n50+t20*t21*t37*abb85n42+t20*t21*t49*abb8&
         &5n51+t20*t21*t71*abb85n50+t21*t22*t58*abb85n45+t21*t24*t84*abb85n40+t2&
         &1*t24*t85*abb85n45)
         return
      end if
      t92 = d(iv3,iv4)
      t93 = d(iv2,iv4)
      t1 = spvak5k6(iv4)
      t94 = d(iv1,iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak3k4(iv4)
      t5 = spvak5k1(iv4)
      t6 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((2.0_ki)*(t1*t68*abb85n23+t1*t69*abb85n23+t1*t86*abb85n23+&
         &t1*t87*abb85n23+t1*t88*abb85n23+t1*t89*abb85n23+t32*t92*abb85n31+t34*t&
         &92*abb85n31+t44*t93*abb85n26+t53*t93*abb85n24+t70*t92*abb85n26+t72*t92&
         &*abb85n26+t73*t93*abb85n31+t77*t92*abb85n24+t78*t93*abb85n27+t79*t92*a&
         &bb85n24+t81*t92*abb85n27+t82*t92*abb85n27+t1*t14*t90*abb85n26+t1*t15*t&
         &90*abb85n24+t1*t16*t90*abb85n31+t1*t24*t90*abb85n27+t1*t33*t91*abb85n3&
         &1+t1*t37*t95*abb85n26+t1*t39*t91*abb85n26+t1*t41*t91*abb85n24+t1*t49*t&
         &95*abb85n24+t1*t58*t95*abb85n27+t1*t61*t91*abb85n27+t1*t71*t95*abb85n3&
         &1+t14*t9*t93*abb85n26+t15*t9*t93*abb85n24+t16*t9*t93*abb85n31+t17*t2*t&
         &90*abb85n26+t17*t3*t90*abb85n24+t17*t4*t90*abb85n27+t17*t5*t90*abb85n3&
         &1+t2*t21*t91*abb85n26+t2*t9*t95*abb85n26+t21*t3*t91*abb85n24+t21*t37*t&
         &94*abb85n26+t21*t4*t91*abb85n27+t21*t49*t94*abb85n24+t21*t5*t91*abb85n&
         &31+t21*t58*t94*abb85n27+t21*t71*t94*abb85n31+t24*t9*t93*abb85n27+t3*t9&
         &*t95*abb85n24+t33*t9*t94*abb85n31+t39*t9*t94*abb85n26+t4*t9*t95*abb85n&
         &27+t41*t9*t94*abb85n24+t5*t9*t95*abb85n31+t61*t9*t94*abb85n27+t13*t21*&
         &t4*t9*abb85n23+t17*t21*t31*t4*abb85n23+t17*t21*t58*t6*abb85n23+t17*t30&
         &*t4*t9*abb85n23+t17*t6*t61*t9*abb85n23+t21*t24*t6*t9*abb85n23))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d85:
   subroutine     reconstruct_d85(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group12
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group12), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_85:
      coeffs%coeffs_85%c0 = derivative(czip)
      coeffs%coeffs_85%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_85%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_85%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_85%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_85%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_85%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_85%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_85%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_85%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_85%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_85%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_85%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_85%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_85%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_85%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_85%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_85%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_85%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_85%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_85%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_85%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_85%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_85%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_85%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_85%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_85%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_85%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_85%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_85%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_85%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_85%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_85%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_85%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_85%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_85%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_85%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_85%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_85%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_85%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_85%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_85%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_85%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_85%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_85%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_85%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_85%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_85%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_85%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_85:
   end subroutine reconstruct_d85
!---#] subroutine reconstruct_d85:
end module p7_dubar_emnebargg_d85h1l1d
