module     p7_dubar_emnebargg_d107h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity3/d107h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d107
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd107h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      real(ki) :: t54
      real(ki) :: t55
      real(ki) :: t56
      real(ki) :: t57
      real(ki) :: t58
      real(ki) :: t59
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t2 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t54 = dotproduct(k6, qshift)
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t55 = dotproduct(k5, qshift)
      t7 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t8 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t56 = dotproduct(qshift, qshift)
      t57 = dotproduct(k1, qshift)
      t58 = dotproduct(k3, qshift)
      t59 = dotproduct(k4, qshift)
      t9 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t10 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-s&
      &pvak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb107n46+t1*abb107n109+t2*abb107n110+t3*abb107n113+t4*abb&
         &107n114+t5*abb107n137+t54*abb107n136+t55*abb107n139+t56*abb107n64+t57*&
         &abb107n89+t58*abb107n90+t59*abb107n90+t6*abb107n138+t7*abb107n140+t8*a&
         &bb107n141+t9*abb107n91+t1*t5*abb107n73+t10*t56*abb107n106+t2*t6*abb107&
         &n74+t3*t54*abb107n69+t3*t55*abb107n70+t3*t56*abb107n123+t4*t54*abb107n&
         &68+t4*t55*abb107n67+t4*t56*abb107n126+t5*t54*abb107n51+t5*t55*abb107n6&
         &6+t5*t56*abb107n129+t5*t6*abb107n49+t5*t7*abb107n47+t54*t57*abb107n85+&
         &t54*t58*abb107n84+t54*t59*abb107n84+t54*t6*abb107n65+t54*t9*abb107n83+&
         &t55*t57*abb107n84+t55*t58*abb107n85+t55*t59*abb107n85+t55*t6*abb107n50&
         &+t55*t9*abb107n82+t56*t57*abb107n96+t56*t58*abb107n93+t56*t59*abb107n9&
         &3+t56*t6*abb107n132+t56*t9*abb107n100+t6*t8*abb107n48+t10*t5*t6*abb107&
         &n108+t3*t5*t6*abb107n134+t4*t5*t6*abb107n135+t5*t57*t6*abb107n102+t5*t&
         &58*t6*abb107n103+t5*t59*t6*abb107n103+t5*t6*t9*abb107n104)
         return
      end if
      t11 = k1(iv1)
      t12 = k3(iv1)
      t13 = k4(iv1)
      t14 = k5(iv1)
      t15 = k6(iv1)
      t16 = qshift(iv1)
      t17 = spvak2k1(iv1)
      t18 = spvak3k1(iv1)
      t19 = spvak3k4(iv1)
      t20 = spvak5k1(iv1)
      t21 = spvak5k4(iv1)
      t22 = spvak5k6(iv1)
      t23 = spvak6k1(iv1)
      t24 = spvak6k4(iv1)
      t25 = spvak6k5(iv1)
      t26 = t14*abb107n93
      t27 = t15*abb107n96
      t28 = t16*abb107n92
      t29 = spvak2k4(iv1)
      t30 = t22*abb107n80
      t31 = t25*abb107n80
      if(deg.eq.1) then
         numerator = (t11*abb107n88+t12*abb107n87+t13*abb107n87+t14*abb107n54+t1&
         &5*abb107n57+t16*abb107n121+t17*abb107n72+t18*abb107n71+t19*abb107n86+t&
         &20*abb107n52+t21*abb107n75+t22*abb107n56+t23*abb107n53+t24*abb107n76+t&
         &25*abb107n55+t26*t58+t26*t59+t27*t58+t27*t59+t28*t58+t28*t59+t1*t22*ab&
         &b107n112+t10*t16*abb107n105+t11*t54*abb107n93+t11*t55*abb107n96+t11*t5&
         &6*abb107n84+t12*t54*abb107n96+t12*t55*abb107n93+t12*t56*abb107n85+t13*&
         &t54*abb107n96+t13*t55*abb107n93+t13*t56*abb107n85+t14*t3*abb107n115+t1&
         &4*t4*abb107n118+t14*t5*abb107n119+t14*t57*abb107n96+t14*t6*abb107n143+&
         &t14*t9*abb107n100+t15*t3*abb107n116+t15*t4*abb107n117+t15*t5*abb107n14&
         &2+t15*t57*abb107n93+t15*t6*abb107n120+t15*t9*abb107n98+t16*t3*abb107n1&
         &22+t16*t4*abb107n125+t16*t5*abb107n128+t16*t57*abb107n95+t16*t6*abb107&
         &n131+t16*t9*abb107n99+t17*t54*abb107n116+t17*t55*abb107n115+t17*t56*ab&
         &b107n63+t18*t54*abb107n117+t18*t55*abb107n118+t18*t56*abb107n62+t19*t5&
         &4*abb107n98+t19*t55*abb107n100+t19*t56*abb107n82+t2*t25*abb107n111+t20&
         &*t6*abb107n145+t21*t6*abb107n111+t22*t54*abb107n142+t22*t55*abb107n119&
         &+t22*t56*abb107n61+t22*t6*abb107n144+t22*t7*abb107n146+t23*t5*abb107n1&
         &46+t24*t5*abb107n112+t25*t5*abb107n144+t25*t54*abb107n120+t25*t55*abb1&
         &07n143+t25*t56*abb107n60+t25*t8*abb107n145+t29*t56*abb107n78+t30*t58*t&
         &6+t30*t59*t6+t31*t5*t58+t31*t5*t59+t10*t22*t6*abb107n77+t10*t25*t5*abb&
         &107n77+t11*t5*t6*abb107n81+t12*t5*t6*abb107n80+t13*t5*t6*abb107n80+t17&
         &*t5*t6*abb107n59+t18*t5*t6*abb107n58+t19*t5*t6*abb107n79+t22*t3*t6*abb&
         &107n59+t22*t4*t6*abb107n58+t22*t57*t6*abb107n81+t22*t6*t9*abb107n79+t2&
         &5*t3*t5*abb107n59+t25*t4*t5*abb107n58+t25*t5*t57*abb107n81+t25*t5*t9*a&
         &bb107n79+t29*t5*t6*abb107n77)
         return
      end if
      t54 = d(iv1,iv2)
      t1 = t54*abb107n93
      t2 = k5(iv2)
      t7 = k6(iv2)
      t8 = qshift(iv2)
      t26 = k1(iv2)
      t27 = k3(iv2)
      t28 = k4(iv2)
      t30 = spvak2k1(iv2)
      t31 = spvak3k1(iv2)
      t32 = spvak3k4(iv2)
      t33 = spvak5k6(iv2)
      t34 = spvak6k5(iv2)
      t35 = spvak2k4(iv2)
      t36 = t22*t34
      t37 = t25*t33
      t38 = t11*t33
      t39 = t22*t26
      t40 = t12*t33
      t41 = t22*t27
      t42 = t13*t33
      t43 = t22*t28
      t44 = t17*t33
      t45 = t22*t30
      t46 = t29*t33
      t47 = t22*t35
      t48 = t18*t33
      t49 = t22*t31
      t50 = t19*t33
      t51 = t22*t32
      t52 = t36*abb107n103
      t53 = t37*abb107n103
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t58+t1*t59+t54*abb107n64+t10*t54*abb107n106+t&
         &3*t54*abb107n123+t4*t54*abb107n126+t5*t54*abb107n129+t54*t57*abb107n96&
         &+t54*t6*abb107n132+t54*t9*abb107n100)+t36*abb107n49+t37*abb107n49+t52*&
         &t58+t52*t59+t53*t58+t53*t59+spvak5k1(iv2)*t25*abb107n48+spvak5k4(iv2)*&
         &t25*abb107n74+spvak6k1(iv2)*t22*abb107n47+spvak6k4(iv2)*t22*abb107n73+&
         &t10*t36*abb107n108+t10*t37*abb107n108+t11*t2*abb107n84+t11*t7*abb107n8&
         &5+t11*t8*abb107n97+t12*t2*abb107n85+t12*t7*abb107n84+t12*t8*abb107n94+&
         &t13*t2*abb107n85+t13*t7*abb107n84+t13*t8*abb107n94+t14*t26*abb107n84+t&
         &14*t27*abb107n85+t14*t28*abb107n85+t14*t30*abb107n70+t14*t31*abb107n67&
         &+t14*t32*abb107n82+t14*t33*abb107n66+t14*t34*abb107n50+t15*t26*abb107n&
         &85+t15*t27*abb107n84+t15*t28*abb107n84+t15*t30*abb107n69+t15*t31*abb10&
         &7n68+t15*t32*abb107n83+t15*t33*abb107n51+t15*t34*abb107n65+t16*t26*abb&
         &107n97+t16*t27*abb107n94+t16*t28*abb107n94+t16*t30*abb107n124+t16*t31*&
         &abb107n127+t16*t32*abb107n101+t16*t33*abb107n130+t16*t34*abb107n133+t1&
         &6*t35*abb107n107+t17*t2*abb107n70+t17*t7*abb107n69+t17*t8*abb107n124+t&
         &18*t2*abb107n67+t18*t7*abb107n68+t18*t8*abb107n127+t19*t2*abb107n82+t1&
         &9*t7*abb107n83+t19*t8*abb107n101+t2*t22*abb107n66+t2*t25*abb107n50+t20&
         &*t34*abb107n48+t21*t34*abb107n74+t22*t7*abb107n51+t22*t8*abb107n130+t2&
         &3*t33*abb107n47+t24*t33*abb107n73+t25*t7*abb107n65+t25*t8*abb107n133+t&
         &29*t8*abb107n107+t3*t36*abb107n134+t3*t37*abb107n134+t36*t4*abb107n135&
         &+t36*t57*abb107n102+t36*t9*abb107n104+t37*t4*abb107n135+t37*t57*abb107&
         &n102+t37*t9*abb107n104+t38*t6*abb107n102+t39*t6*abb107n102+t40*t6*abb1&
         &07n103+t41*t6*abb107n103+t42*t6*abb107n103+t43*t6*abb107n103+t44*t6*ab&
         &b107n134+t45*t6*abb107n134+t46*t6*abb107n108+t47*t6*abb107n108+t48*t6*&
         &abb107n135+t49*t6*abb107n135+t50*t6*abb107n104+t51*t6*abb107n104+t11*t&
         &34*t5*abb107n102+t12*t34*t5*abb107n103+t13*t34*t5*abb107n103+t17*t34*t&
         &5*abb107n134+t18*t34*t5*abb107n135+t19*t34*t5*abb107n104+t25*t26*t5*ab&
         &b107n102+t25*t27*t5*abb107n103+t25*t28*t5*abb107n103+t25*t30*t5*abb107&
         &n134+t25*t31*t5*abb107n135+t25*t32*t5*abb107n104+t25*t35*t5*abb107n108&
         &+t29*t34*t5*abb107n108)
         return
      end if
      t55 = d(iv2,iv3)
      t56 = d(iv1,iv3)
      t1 = k1(iv3)
      t2 = k3(iv3)
      t3 = k4(iv3)
      t4 = spvak2k1(iv3)
      t5 = spvak2k4(iv3)
      t6 = spvak3k1(iv3)
      t7 = spvak3k4(iv3)
      t8 = spvak5k6(iv3)
      t9 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t54*abb107n84+t11*t55*abb107n84+t12*t55*abb10&
         &7n85+t13*t55*abb107n85+t17*t55*abb107n63+t18*t55*abb107n62+t19*t55*abb&
         &107n82+t2*t54*abb107n85+t22*t55*abb107n61+t25*t55*abb107n60+t26*t56*ab&
         &b107n84+t27*t56*abb107n85+t28*t56*abb107n85+t29*t55*abb107n78+t3*t54*a&
         &bb107n85+t30*t56*abb107n63+t31*t56*abb107n62+t32*t56*abb107n82+t33*t56&
         &*abb107n61+t34*t56*abb107n60+t35*t56*abb107n78+t4*t54*abb107n63+t5*t54&
         &*abb107n78+t54*t6*abb107n62+t54*t7*abb107n82+t54*t8*abb107n61+t54*t9*a&
         &bb107n60)+t38*t9*abb107n81+t39*t9*abb107n81+t40*t9*abb107n80+t41*t9*ab&
         &b107n80+t42*t9*abb107n80+t43*t9*abb107n80+t44*t9*abb107n59+t45*t9*abb1&
         &07n59+t46*t9*abb107n77+t47*t9*abb107n77+t48*t9*abb107n58+t49*t9*abb107&
         &n58+t50*t9*abb107n79+t51*t9*abb107n79+t1*t22*t34*abb107n81+t1*t25*t33*&
         &abb107n81+t11*t34*t8*abb107n81+t12*t34*t8*abb107n80+t13*t34*t8*abb107n&
         &80+t17*t34*t8*abb107n59+t18*t34*t8*abb107n58+t19*t34*t8*abb107n79+t2*t&
         &22*t34*abb107n80+t2*t25*t33*abb107n80+t22*t3*t34*abb107n80+t22*t34*t4*&
         &abb107n59+t22*t34*t5*abb107n77+t22*t34*t6*abb107n58+t22*t34*t7*abb107n&
         &79+t25*t26*t8*abb107n81+t25*t27*t8*abb107n80+t25*t28*t8*abb107n80+t25*&
         &t3*t33*abb107n80+t25*t30*t8*abb107n59+t25*t31*t8*abb107n58+t25*t32*t8*&
         &abb107n79+t25*t33*t4*abb107n59+t25*t33*t5*abb107n77+t25*t33*t6*abb107n&
         &58+t25*t33*t7*abb107n79+t25*t35*t8*abb107n77+t29*t34*t8*abb107n77)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d107:
   subroutine     reconstruct_d107(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_107:
      coeffs%coeffs_107%c0 = derivative(czip)
      coeffs%coeffs_107%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_107%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_107%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_107%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_107%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_107%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_107%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_107%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_107%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_107%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_107%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_107%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_107%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_107%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_107%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_107%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_107%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_107%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_107%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_107%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_107%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_107%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_107%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_107%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_107%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_107%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_107%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_107%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_107:
   end subroutine reconstruct_d107
!---#] subroutine reconstruct_d107:
end module p7_dubar_emnebargg_d107h3l1d
