module     p7_dubar_emnebargg_d20h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity3/d20h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d20
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd20h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t40 = dotproduct(qshift, qshift)
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t41 = dotproduct(k6, qshift)
      t42 = dotproduct(k5, qshift)
      t43 = dotproduct(k2, qshift)
      t44 = dotproduct(k3, qshift)
      t45 = dotproduct(k4, qshift)
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb20n102+t2*abb20n104+t3*abb20n35+t4*abb20n69+t40*abb2&
         &0n53+t41*abb20n80+t42*abb20n81+t43*abb20n82+t44*abb20n83+t45*abb20n83+&
         &t5*abb20n70+t1*t6*abb20n65+t2*t40*abb20n96+t2*t44*abb20n48+t2*t45*abb2&
         &0n48+t2*t6*abb20n38+t3*t40*abb20n99+t3*t44*abb20n45+t3*t45*abb20n45+t3&
         &*t6*abb20n43+t4*t41*abb20n55+t4*t42*abb20n56+t40*t41*abb20n77+t40*t42*&
         &abb20n74+t40*t5*abb20n108+t40*t6*abb20n91+t41*t44*abb20n61+t41*t45*abb&
         &20n61+t41*t6*abb20n54+t42*t44*abb20n64+t42*t45*abb20n64+t42*t6*abb20n5&
         &2+t43*t6*abb20n51+t44*t6*abb20n49+t45*t6*abb20n49+t5*t6*abb20n41+t6*t7&
         &*abb20n40+t1*t41*t6*abb20n111+t1*t42*t6*abb20n112)
         return
      end if
      t8 = k2(iv1)
      t9 = k3(iv1)
      t10 = k4(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak2k4(iv1)
      t16 = spvak3k1(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak6k1(iv1)
      t19 = t11*abb20n72
      t20 = t12*abb20n79
      t21 = spvak3k4(iv1)
      t22 = t21*abb20n93
      t23 = spvak4k1(iv1)
      t24 = t17*abb20n94
      t25 = t18*abb20n101
      if(deg.eq.1) then
         numerator = (t10*abb20n57+t11*abb20n59+t12*abb20n60+t13*abb20n87+t14*ab&
         &b20n44+t15*abb20n67+t16*abb20n66+t17*abb20n42+t18*abb20n68+t19*t44+t19&
         &*t45+t20*t44+t20*t45+t22*t44+t22*t45+t24*t44+t24*t45+t25*t44+t25*t45+t&
         &8*abb20n58+t9*abb20n57+t1*t21*abb20n71+t10*t2*abb20n94+t10*t3*abb20n10&
         &1+t10*t41*abb20n79+t10*t42*abb20n72+t10*t6*abb20n93+t11*t4*abb20n84+t1&
         &1*t40*abb20n63+t11*t6*abb20n88+t12*t4*abb20n85+t12*t40*abb20n62+t12*t6&
         &*abb20n86+t13*t2*abb20n95+t13*t3*abb20n98+t13*t41*abb20n76+t13*t42*abb&
         &20n73+t13*t5*abb20n107+t13*t6*abb20n90+t14*t6*abb20n71+t15*t41*abb20n8&
         &5+t15*t42*abb20n84+t16*t40*abb20n39+t16*t6*abb20n105+t17*t40*abb20n47+&
         &t17*t6*abb20n110+t18*t40*abb20n46+t18*t6*abb20n103+t2*t21*abb20n110+t2&
         &*t9*abb20n94+t21*t3*abb20n103+t21*t40*abb20n50+t21*t41*abb20n86+t21*t4&
         &2*abb20n88+t21*t43*abb20n89+t21*t5*abb20n105+t21*t7*abb20n106+t23*t6*a&
         &bb20n106+t3*t9*abb20n101+t41*t9*abb20n79+t42*t9*abb20n72+t6*t8*abb20n8&
         &9+t6*t9*abb20n93+t1*t11*t6*abb20n36+t1*t12*t6*abb20n37+t1*t21*t41*abb2&
         &0n37+t1*t21*t42*abb20n36+t14*t41*t6*abb20n37+t14*t42*t6*abb20n36)
         return
      end if
      t40 = d(iv1,iv2)
      t4 = spvak3k4(iv2)
      t7 = k5(iv2)
      t19 = k6(iv2)
      t20 = spvak5k1(iv2)
      t22 = spvak6k1(iv2)
      t24 = k3(iv2)
      t25 = k4(iv2)
      t26 = qshift(iv2)
      t27 = spvak2k4(iv2)
      t28 = t11*t4
      t29 = t21*t7
      t30 = t12*t4
      t31 = t19*t21
      t32 = spvak3k1(iv2)
      t33 = t14*t4
      t34 = spvak2k1(iv2)
      t35 = t21*t34
      t36 = t11*t34
      t37 = t14*t7
      t38 = t12*t34
      t39 = t14*t19
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t40*abb20n53+t2*t40*abb20n96+t3*t40*abb20n99+t40&
         &*t41*abb20n77+t40*t42*abb20n74+t40*t5*abb20n108+t40*t6*abb20n91)+t28*a&
         &bb20n52+t29*abb20n52+t30*abb20n54+t31*abb20n54+t33*abb20n65+t35*abb20n&
         &65+k2(iv2)*t21*abb20n51+spvak4k1(iv2)*t21*abb20n40+t1*t28*abb20n112+t1&
         &*t29*abb20n112+t1*t30*abb20n111+t1*t31*abb20n111+t10*t19*abb20n61+t10*&
         &t20*abb20n48+t10*t22*abb20n45+t10*t4*abb20n49+t10*t7*abb20n64+t11*t24*&
         &abb20n64+t11*t25*abb20n64+t11*t26*abb20n75+t11*t27*abb20n56+t12*t24*ab&
         &b20n61+t12*t25*abb20n61+t12*t26*abb20n78+t12*t27*abb20n55+t13*t19*abb2&
         &0n78+t13*t20*abb20n97+t13*t22*abb20n100+t13*t32*abb20n109+t13*t4*abb20&
         &n92+t13*t7*abb20n75+t15*t19*abb20n55+t15*t7*abb20n56+t16*t26*abb20n109&
         &+t16*t4*abb20n41+t17*t24*abb20n48+t17*t25*abb20n48+t17*t26*abb20n97+t1&
         &7*t4*abb20n38+t18*t24*abb20n45+t18*t25*abb20n45+t18*t26*abb20n100+t18*&
         &t4*abb20n43+t19*t9*abb20n61+t20*t21*abb20n38+t20*t9*abb20n48+t21*t22*a&
         &bb20n43+t21*t24*abb20n49+t21*t25*abb20n49+t21*t26*abb20n92+t21*t32*abb&
         &20n41+t22*t9*abb20n45+t23*t4*abb20n40+t33*t41*abb20n111+t33*t42*abb20n&
         &112+t35*t41*abb20n111+t35*t42*abb20n112+t36*t6*abb20n112+t37*t6*abb20n&
         &112+t38*t6*abb20n111+t39*t6*abb20n111+t4*t8*abb20n51+t4*t9*abb20n49+t7&
         &*t9*abb20n64)
         return
      end if
      t41 = d(iv2,iv3)
      t42 = d(iv1,iv3)
      t1 = k5(iv3)
      t2 = k6(iv3)
      t3 = spvak3k4(iv3)
      t5 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t40*abb20n39+spvak5k1(iv3)*t40*abb&
         &20n47+spvak6k1(iv3)*t40*abb20n46+t1*t40*abb20n63+t11*t41*abb20n63+t12*&
         &t41*abb20n62+t16*t41*abb20n39+t17*t41*abb20n47+t18*t41*abb20n46+t19*t4&
         &2*abb20n62+t2*t40*abb20n62+t20*t42*abb20n47+t21*t41*abb20n50+t22*t42*a&
         &bb20n46+t3*t40*abb20n50+t32*t42*abb20n39+t4*t42*abb20n50+t42*t7*abb20n&
         &63)+t3*t36*abb20n36+t3*t37*abb20n36+t3*t38*abb20n37+t3*t39*abb20n37+t1&
         &*t14*t4*abb20n36+t1*t21*t34*abb20n36+t11*t4*t5*abb20n36+t12*t4*t5*abb2&
         &0n37+t14*t2*t4*abb20n37+t19*t21*t5*abb20n37+t2*t21*t34*abb20n37+t21*t5&
         &*t7*abb20n36)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d20:
   subroutine     reconstruct_d20(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_20:
      coeffs%coeffs_20%c0 = derivative(czip)
      coeffs%coeffs_20%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_20%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_20%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_20%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_20%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_20%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_20%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_20%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_20%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_20%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_20%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_20%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_20%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_20%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_20%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_20%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_20%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_20%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_20%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_20%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_20%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_20%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_20%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_20%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_20%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_20%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_20%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_20%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_20%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_20%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_20%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_20%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_20%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_20%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_20:
   end subroutine reconstruct_d20
!---#] subroutine reconstruct_d20:
end module p7_dubar_emnebargg_d20h3l1d
