module     p0_dd_emnebardu_abbrevd10h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb10n1
   complex(ki), public :: abb10n2
   complex(ki), public :: abb10n3
   complex(ki), public :: abb10n4
   complex(ki), public :: abb10n5
   complex(ki), public :: abb10n6
   complex(ki), public :: rat2d10
   complex(ki), public :: abb10n8
   complex(ki), public :: abb10n9
   complex(ki), public :: abb10n10
   complex(ki), public :: abb10n11
   complex(ki), public :: abb10n12
   complex(ki), public :: abb10n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   real(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t19 = TR*TR
      t2 = t19*t1*spak3k5*spak5k6*spbk4k1*spbk5k2
      t3 = (es34+es61-(es345+es234))*(es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*&
      &mW)
      t4 = t2/t3
      t5 = t19*t1*spak3k6*spak5k6*spbk4k1*spbk6k2
      t6 = t5/t3
      t7 = NC*NC*t3
      t2 = t2/t7
      t5 = t5/t7
      t8 = c1*i_
      t9 = NC*t3
      t10 = t19*t8/t9*spak3k5*spak5k6*spbk4k1*spbk5k2
      t11 = t19*t8/t9*spak3k6*spak5k6*spbk4k1*spbk6k2
      t12 = NC*c1*i_
      t13 = t19*t12/t3*spak3k5*spak5k6*spbk4k1*spbk5k2
      t14 = t19*t12/t3*spak3k6*spak5k6*spbk4k1*spbk6k2
      abb10n1 = ((2.0_ki)*(t10+t11+t4+t6-(t5+t2+t14+t13)))
      t15 = t1*spak3k4*spak5k6*spbk4k1
      t16 = t19*t15*spbk5k2
      t17 = t8*spak3k4*spak5k6*spbk4k1
      t18 = t12*spak3k4*spak5k6*spbk4k1
      abb10n2 = ((4.0_ki)*(t16/t3+t19*t17/t9*spbk5k2-(t19*t18/t3*spbk5k2+t16/t7)&
      &))
      t15 = t19*t15*spbk6k2
      abb10n3 = ((4.0_ki)*(t15/t3+t19*t17/t9*spbk6k2-(t19*t18/t3*spbk6k2+t15/t7)&
      &))
      abb10n4 = ((4.0_ki)*(t13+t14+t2+t5-(t6+t4+t11+t10)))
      t1 = t1*spak5k6
      t2 = t19*t1*spbk5k2
      t4 = t8*spak5k6
      t5 = t12*spak5k6
      abb10n5 = ((4.0_ki)*(t2/t7+t19/t3*t5*spbk5k2-(t19*t4/t9*spbk5k2+t2/t3)))
      t1 = t19*t1*spbk6k2
      abb10n6 = ((4.0_ki)*(t1/t7+t19/t3*t5*spbk6k2-(t19*t4/t9*spbk6k2+t1/t3)))
      rat2d10 = abb10n1
      rat2 = rat2 + rat2d10
      abb10n8 = -(abb10n3)
      abb10n9 = abb10n6
      abb10n10 = abb10n5
      abb10n11 = abb10n4
      abb10n12 = -(abb10n2)
      abb10n13 = ((2.0_ki)*abb10n4)
   end subroutine
end module p0_dd_emnebardu_abbrevd10h0
