module     p0_dd_emnebardu_abbrevd51h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb51n1
   complex(ki), public :: abb51n2
   complex(ki), public :: abb51n3
   complex(ki), public :: abb51n4
   complex(ki), public :: abb51n5
   complex(ki), public :: abb51n6
   complex(ki), public :: abb51n7
   complex(ki), public :: abb51n8
   complex(ki), public :: abb51n9
   complex(ki), public :: rat2d51
   complex(ki), public :: abb51n11
   complex(ki), public :: abb51n12
   complex(ki), public :: abb51n13
   complex(ki), public :: abb51n14
   complex(ki), public :: abb51n15
   complex(ki), public :: abb51n16
   complex(ki), public :: abb51n17
   complex(ki), public :: abb51n18
   complex(ki), public :: abb51n19
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   real(ki) :: t50
   real(ki) :: t51
   real(ki) :: t52
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t50 = es12+es34-(es56+es345)
      t2 = es34*c1*i_
      t51 = TR*TR
      t3 = t51*t2*spak3k5*spak3k6*spbk2k1*spbk4k3
      t4 = (es234-(es61+es56))*t1
      t52 = t50*t50
      t5 = t52*t4
      t2 = t51*t2*spak3k6*spak5k6*spbk2k1*spbk6k4
      t6 = es345*c1*i_
      t7 = t51*t6*spak3k5*spak3k6*spbk2k1*spbk4k3
      t6 = t51*t6*spak3k6*spak5k6*spbk2k1*spbk6k4
      t8 = es56*c1*i_
      t9 = t51*t8*spak3k5*spak3k6*spbk2k1*spbk4k3
      t8 = t51*t8*spak3k6*spak5k6*spbk2k1*spbk6k4
      t10 = c1*i_
      t11 = t10*spak1k3
      t12 = TR*spbk2k1
      t12 = t12*t12
      t13 = t11*t12*spak2k5*spak3k6*spbk4k3
      t14 = t10*spak1k5
      t15 = t12*t14*spak2k3*spak3k6*spbk4k3
      t16 = t12*t14*spak2k6*spak3k6*spbk6k4
      t17 = t10*spak1k6
      t18 = t12*t17*spak2k5*spak3k6*spbk6k4
      t19 = es34*c2*i_
      t20 = t51*t19*spak3k5*spak3k6*spbk2k1*spbk4k3
      t1 = (es34+es61-(es345+es234))*t1
      t21 = t52*t1
      t19 = t51*t19*spak3k6*spak5k6*spbk2k1*spbk6k4
      t22 = es345*c2*i_
      t23 = t51*t22*spak3k5*spak3k6*spbk2k1*spbk4k3
      t22 = t51*t22*spak3k6*spak5k6*spbk2k1*spbk6k4
      t24 = es56*c2*i_
      t25 = t51*t24*spak3k5*spak3k6*spbk2k1*spbk4k3
      t24 = t51*t24*spak3k6*spak5k6*spbk2k1*spbk6k4
      t26 = c2*i_
      t27 = t26*spak1k3
      t28 = t12*t27*spak2k5*spak3k6*spbk4k3
      t29 = t26*spak1k5
      t30 = t12*t29*spak2k3*spak3k6*spbk4k3
      t31 = t12*t29*spak2k6*spak3k6*spbk6k4
      t32 = t26*spak1k6
      t33 = t12*t32*spak2k5*spak3k6*spbk6k4
      t50 = t50*NC
      t50 = t50*t50
      t34 = t50*t4
      t4 = NC*t52*t4
      t35 = NC*c2
      t36 = es34*t35*i_
      t37 = es345*t35*i_
      t38 = es56*t35*i_
      t35 = t35*i_
      t39 = t35*spak1k3
      t40 = t35*spak1k5
      t41 = t35*spak1k6
      t42 = t50*t1
      t1 = NC*t52*t1
      t43 = NC*c1
      t44 = es34*t43*i_
      t45 = es345*t43*i_
      t46 = es56*t43*i_
      t43 = t43*i_
      t47 = t43*spak1k3
      t48 = t43*spak1k5
      t49 = t43*spak1k6
      abb51n1 = ((4.0_ki)*(t13/t1+t16/t1+t2/t1+t3/t1+t13/t5+t15/t34+t16/t5+t18/t&
      &34+t19/t21+t19/t4+t2/t5+t20/t21+t20/t4+t28/t21+t31/t21+t22/t42+t23/t42+t2&
      &4/t42+t25/t42+t28/t4+t3/t5+t30/t42+t31/t4+t33/t42+t6/t34+t7/t34+t8/t34+t9&
      &/t34+t12/t21*t48*spak2k3*spak3k6*spbk4k3+t12/t21*t49*spak2k5*spak3k6*spbk&
      &6k4+t12*t40/t5*spak2k3*spak3k6*spbk4k3+t12*t41/t5*spak2k5*spak3k6*spbk6k4&
      &+t51*t45/t21*spak3k5*spak3k6*spbk2k1*spbk4k3+t51*t45/t21*spak3k6*spak5k6*&
      &spbk2k1*spbk6k4+t51*t46/t21*spak3k5*spak3k6*spbk2k1*spbk4k3+t51*t46/t21*s&
      &pak3k6*spak5k6*spbk2k1*spbk6k4+t51*t37/t5*spak3k5*spak3k6*spbk2k1*spbk4k3&
      &+t51*t37/t5*spak3k6*spak5k6*spbk2k1*spbk6k4+t51*t38/t5*spak3k5*spak3k6*sp&
      &bk2k1*spbk4k3+t51*t38/t5*spak3k6*spak5k6*spbk2k1*spbk6k4-(t51*t36/t5*spak&
      &3k6*spak5k6*spbk2k1*spbk6k4+t51*t36/t5*spak3k5*spak3k6*spbk2k1*spbk4k3+t5&
      &1*t44/t21*spak3k6*spak5k6*spbk2k1*spbk6k4+t51*t44/t21*spak3k5*spak3k6*spb&
      &k2k1*spbk4k3+t12*t40/t5*spak2k6*spak3k6*spbk6k4+t12*t39/t5*spak2k5*spak3k&
      &6*spbk4k3+t12/t21*t48*spak2k6*spak3k6*spbk6k4+t12/t21*t47*spak2k5*spak3k6&
      &*spbk4k3+t9/t5+t8/t5+t7/t5+t6/t5+t33/t4+t31/t42+t30/t4+t3/t34+t28/t42+t25&
      &/t4+t24/t4+t23/t4+t22/t4+t33/t21+t30/t21+t25/t21+t24/t21+t23/t21+t22/t21+&
      &t20/t42+t2/t34+t19/t42+t18/t5+t16/t34+t15/t5+t13/t34+t9/t1+t8/t1+t7/t1+t6&
      &/t1+t18/t1+t15/t1)))
      t2 = t14*spak3k6*spbk2k1
      t3 = t51*t2*spbk4k3
      t6 = t29*spak3k6*spbk2k1
      t7 = t51*t6*spbk4k3
      t8 = t40*spak3k6*spbk2k1
      t9 = t48*spak3k6*spbk2k1
      abb51n2 = ((4.0_ki)*(t3/t1+t7/t21+t3/t5+t7/t4-(t51/t5*t8*spbk4k3+t51/t21*t&
      &9*spbk4k3+t7/t42+t3/t34)))
      t2 = t51*t2*spbk6k4
      t3 = t51*t6*spbk6k4
      abb51n3 = ((4.0_ki)*(t2/t34+t3/t42+t51/t21*t9*spbk6k4+t51/t5*t8*spbk6k4-(t&
      &3/t4+t3/t21+t2/t5+t2/t1)))
      t2 = t10*spak2k5*spak3k6*spbk2k1
      t3 = t51*t2*spbk4k3
      t6 = t26*spak2k5*spak3k6*spbk2k1
      t7 = t51*t6*spbk4k3
      t8 = t35*spak2k5*spak3k6*spbk2k1
      t9 = t43*spak2k5*spak3k6*spbk2k1
      abb51n4 = ((4.0_ki)*(t3/t1+t7/t21+t3/t5+t7/t4-(t51/t5*t8*spbk4k3+t51/t21*t&
      &9*spbk4k3+t7/t42+t3/t34)))
      t2 = t51*t2*spbk6k4
      t3 = t51*t6*spbk6k4
      abb51n5 = ((4.0_ki)*(t2/t34+t3/t42+t51/t21*t9*spbk6k4+t51/t5*t8*spbk6k4-(t&
      &3/t4+t3/t21+t2/t5+t2/t1)))
      t2 = t10*spak3k5*spak3k6
      t3 = t51*t2*spbk2k1*spbk4k3
      t6 = t3/t5
      t7 = t10*spak3k6*spak5k6
      t8 = t51*t7*spbk2k1*spbk6k4
      t9 = t8/t5
      t12 = t26*spak3k5*spak3k6
      t13 = t51*t12*spbk2k1*spbk4k3
      t14 = t13/t21
      t15 = t26*spak3k6*spak5k6
      t16 = t51*t15*spbk2k1*spbk6k4
      t18 = t16/t21
      t19 = t3/t34
      t20 = t8/t34
      t22 = t13/t4
      t23 = t16/t4
      t24 = t35*spak3k5*spak3k6
      t25 = t51*t24/t5*spbk2k1*spbk4k3
      t28 = t35*spak3k6*spak5k6
      t29 = t51*t28/t5*spbk2k1*spbk6k4
      t13 = t13/t42
      t16 = t16/t42
      t3 = t3/t1
      t8 = t8/t1
      t30 = t43*spak3k5*spak3k6
      t31 = t51*t30/t21*spbk2k1*spbk4k3
      t33 = t43*spak3k6*spak5k6
      t36 = t51*t33/t21*spbk2k1*spbk6k4
      abb51n6 = ((16.0_ki)*(t13+t16+t19+t20+t25+t29+t31+t36-(t9+t8+t6+t3+t23+t22&
      &+t18+t14)))
      abb51n7 = ((16.0_ki)*(t14+t18+t22+t23+t3+t6+t8+t9-(t36+t31+t29+t25+t20+t19&
      &+t16+t13)))
      t3 = t51*t10*spak2k3*spak3k6*spbk2k1*spbk4k3
      t6 = t51*t10*spak2k6*spak3k6*spbk2k1*spbk6k4
      t2 = t2*spbk4k3
      t8 = t51*t2*spbk5k1
      t9 = t51*t7*spbk5k1*spbk6k4
      t10 = t51*t26*spak2k3*spak3k6*spbk2k1*spbk4k3
      t13 = t51*t26*spak2k6*spak3k6*spbk2k1*spbk6k4
      t12 = t12*spbk4k3
      t14 = t51*t12*spbk5k1
      t16 = t51*t15*spbk5k1*spbk6k4
      t18 = t24*spbk4k3
      t19 = t30*spbk4k3
      abb51n8 = ((8.0_ki)*(t6/t1+t10/t42+t13/t21+t13/t4+t14/t42+t16/t42+t3/t34+t&
      &8/t34+t9/t34+t6/t5+t51*t18/t5*spbk5k1+t51*t19/t21*spbk5k1+t51*t33/t21*spb&
      &k5k1*spbk6k4+t51*t28/t5*spbk5k1*spbk6k4+t51*t43/t21*spak2k3*spak3k6*spbk2&
      &k1*spbk4k3+t51*t35/t5*spak2k3*spak3k6*spbk2k1*spbk4k3-(t51*t35/t5*spak2k6&
      &*spak3k6*spbk2k1*spbk6k4+t51*t43/t21*spak2k6*spak3k6*spbk2k1*spbk6k4+t9/t&
      &5+t8/t5+t6/t34+t3/t5+t16/t4+t16/t21+t14/t4+t14/t21+t13/t42+t10/t4+t10/t21&
      &+t9/t1+t8/t1+t3/t1)))
      t3 = t51*t11*spak3k6*spbk2k1*spbk4k3
      t6 = t51*t17*spak3k6*spbk2k1*spbk6k4
      t2 = t51*t2*spbk5k2
      t7 = t51*t7*spbk5k2*spbk6k4
      t8 = t51*t27*spak3k6*spbk2k1*spbk4k3
      t9 = t51*t32*spak3k6*spbk2k1*spbk6k4
      t10 = t51*t12*spbk5k2
      t11 = t51*t15*spbk5k2*spbk6k4
      abb51n9 = ((8.0_ki)*(t2/t1+t6/t1+t7/t1+t10/t21+t10/t4+t11/t21+t11/t4+t2/t5&
      &+t9/t21+t3/t34+t9/t4+t8/t42+t6/t5+t7/t5+t51*t47/t21*spak3k6*spbk2k1*spbk4&
      &k3+t51*t39/t5*spak3k6*spbk2k1*spbk4k3-(t51*t41/t5*spak3k6*spbk2k1*spbk6k4&
      &+t51*t49/t21*spak3k6*spbk2k1*spbk6k4+t51*t28/t5*spbk5k2*spbk6k4+t51*t33/t&
      &21*spbk5k2*spbk6k4+t51*t19/t21*spbk5k2+t51*t18/t5*spbk5k2+t9/t42+t8/t4+t7&
      &/t34+t6/t34+t3/t5+t8/t21+t2/t34+t11/t42+t10/t42+t3/t1)))
      rat2d51 = 0
      rat2 = rat2 + rat2d51
      abb51n11 = abb51n1
      abb51n12 = -(abb51n2)
      abb51n13 = -(abb51n3)
      abb51n14 = -(abb51n4)
      abb51n15 = -(abb51n5)
      abb51n16 = -(abb51n6)
      abb51n17 = -(abb51n7)
      abb51n18 = -(abb51n8)
      abb51n19 = -(abb51n9)
   end subroutine
end module p0_dd_emnebardu_abbrevd51h0
