module     p0_dd_emnebardu_abbrevd7h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb7n1
   complex(ki), public :: abb7n2
   complex(ki), public :: abb7n3
   complex(ki), public :: abb7n4
   complex(ki), public :: abb7n5
   complex(ki), public :: abb7n6
   complex(ki), public :: abb7n7
   complex(ki), public :: abb7n8
   complex(ki), public :: abb7n9
   complex(ki), public :: abb7n10
   complex(ki), public :: abb7n11
   complex(ki), public :: rat2d7
   complex(ki), public :: abb7n13
   complex(ki), public :: abb7n14
   complex(ki), public :: abb7n15
   complex(ki), public :: abb7n16
   complex(ki), public :: abb7n17
   complex(ki), public :: abb7n18
   complex(ki), public :: abb7n19
   complex(ki), public :: abb7n20
   complex(ki), public :: abb7n21
   complex(ki), public :: abb7n22
   complex(ki), public :: abb7n23
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   real(ki) :: t48
   real(ki) :: t49
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t48 = es12+es34-(es56+es345)
      t2 = c1*i_
      t3 = t2*spak1k5
      t4 = t3*spak3k6*spbk2k1
      t49 = TR*TR
      t5 = t49*t4*spbk4k1
      t6 = t48*(es234-(es61+es56))*t1
      t7 = t5/t6
      t8 = t2*spak2k5
      t9 = t8*spak3k6*spbk2k1
      t10 = t49*t9*spbk4k2
      t11 = t10/t6
      t12 = c2*i_
      t13 = t12*spak1k5
      t14 = t13*spak3k6*spbk2k1
      t15 = t49*t14*spbk4k1
      t1 = t48*(es34+es61-(es345+es234))*t1
      t16 = t15/t1
      t17 = t12*spak2k5
      t18 = t17*spak3k6*spbk2k1
      t19 = t49*t18*spbk4k2
      t20 = t19/t1
      t48 = NC*NC
      t21 = t48*t6
      t22 = t5/t21
      t23 = t10/t21
      t24 = NC*t6
      t25 = t15/t24
      t26 = t19/t24
      t27 = NC*c2*i_
      t28 = t27*spak1k5
      t29 = t28*spak3k6*spbk2k1
      t30 = t49*t29/t6*spbk4k1
      t31 = t27*spak2k5
      t32 = t31*spak3k6*spbk2k1
      t33 = t49*t32/t6*spbk4k2
      t34 = t48*t1
      t15 = t15/t34
      t19 = t19/t34
      t35 = NC*t1
      t5 = t5/t35
      t10 = t10/t35
      t36 = NC*c1*i_
      t37 = t36*spak1k5
      t38 = t37*spak3k6*spbk2k1
      t39 = t49*t38/t1*spbk4k1
      t40 = t36*spak2k5
      t41 = t40*spak3k6*spbk2k1
      t42 = t49*t41/t1*spbk4k2
      t43 = t10+t11+t16+t20+t25+t26+t5+t7-(t42+t39+t33+t30+t23+t22+t19+t15)
      abb7n1 = ((2.0_ki)*t43)
      t44 = t49*t3*spbk2k1
      t45 = t49*t13*spbk2k1
      abb7n2 = ((4.0_ki)*(t45/t1+t45/t24+t44/t35+t44/t6-(t49*t28/t6*spbk2k1+t49*&
      &t37/t1*spbk2k1+t45/t34+t44/t21)))
      t44 = t49*t3*spak3k4*spbk2k1*spbk4k1
      t45 = t49*t8*spak3k4*spbk2k1*spbk4k2
      t46 = t49*t13*spak3k4*spbk2k1*spbk4k1
      t47 = t49*t17*spak3k4*spbk2k1*spbk4k2
      abb7n3 = ((4.0_ki)*(t44/t21+t45/t21+t46/t34+t47/t34+t49*t37/t1*spak3k4*spb&
      &k2k1*spbk4k1+t49*t40/t1*spak3k4*spbk2k1*spbk4k2+t49*t28/t6*spak3k4*spbk2k&
      &1*spbk4k1+t49*t31/t6*spak3k4*spbk2k1*spbk4k2-(t45/t6+t44/t6+t45/t35+t44/t&
      &35+t47/t24+t46/t24+t47/t1+t46/t1)))
      abb7n4 = ((4.0_ki)*(t15+t19+t22+t23+t30+t33+t39+t42-(t7+t5+t26+t25+t20+t16&
      &+t11+t10)))
      abb7n5 = ((8.0_ki)*t43)
      t4 = t49*t4*spbk3k1
      t3 = t49*t3*spak4k6*spbk2k1*spbk4k1
      t5 = t49*t9*spbk3k2
      t7 = t49*t8*spak4k6*spbk2k1*spbk4k2
      t9 = t49*t14*spbk3k1
      t10 = t49*t13*spak4k6*spbk2k1*spbk4k1
      t11 = t49*t18*spbk3k2
      t13 = t49*t17*spak4k6*spbk2k1*spbk4k2
      abb7n6 = ((4.0_ki)*(t10/t34+t11/t34+t13/t34+t3/t21+t4/t21+t5/t21+t7/t21+t9&
      &/t34+t49*t38/t1*spbk3k1+t49*t41/t1*spbk3k2+t49*t29/t6*spbk3k1+t49*t32/t6*&
      &spbk3k2+t49*t37/t1*spak4k6*spbk2k1*spbk4k1+t49*t40/t1*spak4k6*spbk2k1*spb&
      &k4k2+t49*t28/t6*spak4k6*spbk2k1*spbk4k1+t49*t31/t6*spak4k6*spbk2k1*spbk4k&
      &2-(t7/t6+t5/t6+t4/t6+t7/t35+t5/t35+t4/t35+t3/t6+t3/t35+t9/t24+t13/t24+t11&
      &/t24+t10/t24+t9/t1+t13/t1+t11/t1+t10/t1)))
      t3 = t49*t8*spbk2k1
      t4 = t49*t17*spbk2k1
      abb7n7 = ((4.0_ki)*(t4/t1+t4/t24+t3/t35+t3/t6-(t49*t31/t6*spbk2k1+t49*t40/&
      &t1*spbk2k1+t4/t34+t3/t21)))
      t3 = t2*spak5k6
      t4 = t49*t3*spbk2k1
      t5 = t4/t6
      t7 = t12*spak5k6
      t8 = t49*t7*spbk2k1
      t9 = t8/t1
      t10 = t4/t21
      t11 = t8/t24
      t13 = t27*spak5k6
      t14 = t49*t13/t6*spbk2k1
      t8 = t8/t34
      t4 = t4/t35
      t15 = t36*spak5k6
      t16 = t49*t15/t1*spbk2k1
      abb7n8 = ((16.0_ki)*(t10+t14+t16+t8-(t9+t5+t4+t11)))
      abb7n9 = ((16.0_ki)*(t11+t4+t5+t9-(t8+t16+t14+t10)))
      t4 = t49*t2*spak2k6*spbk2k1
      t5 = t49*t3*spbk5k1
      t8 = t49*t12*spak2k6*spbk2k1
      t9 = t49*t7*spbk5k1
      abb7n10 = ((8.0_ki)*(t9/t1+t4/t21+t9/t24+t8/t34+t5/t35+t5/t6+t49*t36/t1*sp&
      &ak2k6*spbk2k1+t49*t27/t6*spak2k6*spbk2k1-(t49*t13/t6*spbk5k1+t49*t15/t1*s&
      &pbk5k1+t4/t6+t4/t35+t9/t34+t8/t24+t5/t21+t8/t1)))
      t2 = t49*t2*spak1k6*spbk2k1
      t3 = t49*t3*spbk5k2
      t4 = t49*t12*spak1k6*spbk2k1
      t5 = t49*t7*spbk5k2
      abb7n11 = ((8.0_ki)*(t2/t21+t3/t21+t4/t34+t5/t34+t49*t15/t1*spbk5k2+t49*t1&
      &3/t6*spbk5k2+t49*t36/t1*spak1k6*spbk2k1+t49*t27/t6*spak1k6*spbk2k1-(t3/t6&
      &+t3/t35+t5/t24+t4/t24+t2/t6+t2/t35+t5/t1+t4/t1)))
      rat2d7 = abb7n1
      rat2 = rat2 + rat2d7
      abb7n13 = -(abb7n3)
      abb7n14 = abb7n11
      abb7n15 = abb7n10
      abb7n16 = abb7n9
      abb7n17 = abb7n8
      abb7n18 = abb7n7
      abb7n19 = abb7n4
      abb7n20 = abb7n2
      abb7n21 = ((2.0_ki)*abb7n4)
      abb7n22 = -(abb7n5)
      abb7n23 = -(abb7n6)
   end subroutine
end module p0_dd_emnebardu_abbrevd7h0
