module     p0_dd_emnebardu_abbrevd62h1
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh1
   implicit none
   private
   complex(ki), public :: abb62n1
   complex(ki), public :: abb62n2
   complex(ki), public :: abb62n3
   complex(ki), public :: abb62n4
   complex(ki), public :: abb62n5
   complex(ki), public :: abb62n6
   complex(ki), public :: abb62n7
   complex(ki), public :: abb62n8
   complex(ki), public :: abb62n9
   complex(ki), public :: abb62n10
   complex(ki), public :: abb62n11
   complex(ki), public :: abb62n12
   complex(ki), public :: abb62n13
   complex(ki), public :: rat2d62
   complex(ki), public :: abb62n15
   complex(ki), public :: abb62n16
   complex(ki), public :: abb62n17
   complex(ki), public :: abb62n18
   complex(ki), public :: abb62n19
   complex(ki), public :: abb62n20
   complex(ki), public :: abb62n21
   complex(ki), public :: abb62n22
   complex(ki), public :: abb62n23
   complex(ki), public :: abb62n24
   complex(ki), public :: abb62n25
   complex(ki), public :: abb62n26
   complex(ki), public :: abb62n27
   complex(ki), public :: abb62n28
   complex(ki), public :: abb62n29
   complex(ki), public :: abb62n30
   complex(ki), public :: abb62n31
   complex(ki), public :: abb62n32
   complex(ki), public :: abb62n33
   complex(ki), public :: abb62n34
   complex(ki), public :: abb62n35
   complex(ki), public :: abb62n36
   complex(ki), public :: abb62n37
   complex(ki), public :: abb62n38
   complex(ki), public :: abb62n39
   complex(ki), public :: abb62n40
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k6
      t4 = t3*spak3k4*spbk4k2
      t13 = TR*TR
      t5 = t13*t4*spbk6k5
      t6 = es234*t1
      t7 = NC*NC*t6
      t8 = c2*i_
      t9 = t8*spak1k6
      t10 = t9*spak3k4*spbk4k2
      t1 = es234*NC*t1
      abb62n1 = ((4.0_ki)*(t13*(2.0_ki)/t1*t10*spbk6k5-(t5/t7+t5/t6)))
      t5 = t3*spak2k3*spbk4k2
      t11 = t13*t5*spbk6k5
      t12 = t9*spak2k3*spbk4k2
      abb62n2 = ((4.0_ki)*(t13*(2.0_ki)/t1*t12*spbk6k5-(t11/t7+t11/t6)))
      t11 = t13*t3*spbk3k2
      abb62n3 = ((4.0_ki)*(t13*(2.0_ki)/t1*t9*spbk3k2-(t11/t7+t11/t6)))
      t5 = t13*t5*spbk5k2
      t4 = t13*t4*spbk5k4
      abb62n4 = ((8.0_ki)*(-(t13*t12/t1*spbk5k2+t13*t10/t1*spbk5k4))+(4.0_ki)*(t&
      &4/t6+t4/t7+t5/t6+t5/t7))
      t4 = t13*t3*spbk4k2
      t5 = t4/t6
      t4 = t4/t7
      t10 = t13*(2.0_ki)/t1*t9*spbk4k2
      t11 = t4+t5-t10
      abb62n5 = ((8.0_ki)*t11)
      abb62n6 = ((4.0_ki)*t11)
      t4 = t10-(t5+t4)
      abb62n7 = ((4.0_ki)*t4)
      abb62n8 = ((8.0_ki)*t4)
      t3 = t13*t3*spbk4k3
      abb62n9 = ((4.0_ki)*(t13*(2.0_ki)/t1*t9*spbk4k3-(t3/t7+t3/t6)))
      t3 = t2*spak3k6
      t4 = t13*t3*spbk4k2
      t5 = t4/t6
      t4 = t4/t7
      t9 = t8*spak3k6
      t10 = t13*(2.0_ki)/t1*t9*spbk4k2
      abb62n10 = ((8.0_ki)*(t4+t5-t10))
      abb62n11 = ((8.0_ki)*(t10-(t5+t4)))
      t4 = t13*t3*spbk3k2
      t5 = t13*t2*spak4k6*spbk4k2
      abb62n12 = ((8.0_ki)*(-(t13/t1*t8*spak4k6*spbk4k2+t13/t1*t9*spbk3k2))+(4.0&
      &_ki)*(t4/t6+t4/t7+t5/t6+t5/t7))
      t2 = t13*t2*spak2k6*spbk4k2
      t3 = t13*t3*spbk4k3
      abb62n13 = ((8.0_ki)*(t13/t1*t8*spak2k6*spbk4k2-t13/t1*t9*spbk4k3)+(4.0_ki&
      &)*(t3/t6+t3/t7-(t2/t7+t2/t6)))
      rat2d62 = 0
      rat2 = rat2 + rat2d62
      abb62n15 = -(abb62n1)
      abb62n16 = abb62n13
      abb62n17 = abb62n12
      abb62n18 = abb62n11
      abb62n19 = abb62n10
      abb62n20 = abb62n9
      abb62n21 = abb62n8
      abb62n22 = abb62n7
      abb62n23 = abb62n6
      abb62n24 = abb62n5
      abb62n25 = abb62n4
      abb62n26 = abb62n3
      abb62n27 = abb62n2
      abb62n28 = abb62n1
      abb62n29 = -(abb62n2)
      abb62n30 = -(abb62n3)
      abb62n31 = (-2.0_ki)*abb62n4
      abb62n32 = -(abb62n5)
      abb62n33 = -(abb62n6)
      abb62n34 = -(abb62n7)
      abb62n35 = -(abb62n8)
      abb62n36 = -(abb62n9)
      abb62n37 = -(abb62n10)
      abb62n38 = -(abb62n11)
      abb62n39 = -(abb62n12)
      abb62n40 = -(abb62n13)
   end subroutine
end module p0_dd_emnebardu_abbrevd62h1
