module     p0_dd_emnebardu_d3h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity1/d3h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd3h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t36 = dotproduct(qshift, qshift)
      t37 = dotproduct(k5, qshift)
      t38 = dotproduct(k1, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t39 = dotproduct(k6, qshift)
      t40 = dotproduct(k2, qshift)
      t2 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t3 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t6 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t7 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t8 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n34+t1*abb3n57+t2*abb3n63+t3*abb3n66+t36*abb3n46+t37*a&
         &bb3n53+t38*abb3n54+t39*abb3n58+t4*abb3n67+t40*abb3n59+t1*t36*abb3n60+t&
         &1*t4*abb3n41+t1*t40*abb3n47+t1*t6*abb3n52+t1*t8*abb3n48+t2*t3*abb3n38+&
         &t3*t39*abb3n42+t3*t4*abb3n49+t3*t40*abb3n43+t3*t5*abb3n35+t3*t6*abb3n3&
         &6+t3*t7*abb3n40+t36*t4*abb3n68+t36*t5*abb3n64+t36*t7*abb3n55+t37*t4*ab&
         &b3n37+t37*t5*abb3n45+t37*t7*abb3n50+t38*t4*abb3n39+t38*t5*abb3n44+t38*&
         &t7*abb3n51+t4*t40*abb3n39+t40*t5*abb3n44+t40*t7*abb3n51+t1*t3*t6*abb3n&
         &70)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak1k2(iv1)
      t15 = spvak1k5(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k2(iv1)
      t18 = t14*abb3n39
      t19 = spvak3k2(iv1)
      t20 = t19*abb3n44
      t21 = spvak6k2(iv1)
      t22 = spvak6k4(iv1)
      t23 = t22*abb3n51
      t24 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb3n59+t11*abb3n53+t12*abb3n58+t13*abb3n62+t14*abb3n6&
         &7+t15*abb3n66+t16*abb3n57+t17*abb3n63+t18*t38+t18*t40+t20*t38+t20*t40+&
         &t23*t38+t23*t40+t9*abb3n54+t1*t10*abb3n47+t1*t13*abb3n61+t1*t14*abb3n4&
         &1+t1*t21*abb3n52+t1*t24*abb3n48+t10*t3*abb3n43+t10*t4*abb3n39+t10*t5*a&
         &bb3n44+t10*t7*abb3n51+t11*t4*abb3n37+t11*t5*abb3n45+t11*t7*abb3n50+t12&
         &*t3*abb3n42+t13*t4*abb3n69+t13*t5*abb3n65+t13*t7*abb3n56+t14*t3*abb3n4&
         &9+t14*t36*abb3n68+t14*t37*abb3n37+t15*t2*abb3n38+t15*t39*abb3n42+t15*t&
         &4*abb3n49+t15*t40*abb3n43+t15*t5*abb3n35+t15*t6*abb3n36+t15*t7*abb3n40&
         &+t16*t36*abb3n60+t16*t4*abb3n41+t16*t40*abb3n47+t16*t6*abb3n52+t16*t8*&
         &abb3n48+t17*t3*abb3n38+t19*t3*abb3n35+t19*t36*abb3n64+t19*t37*abb3n45+&
         &t21*t3*abb3n36+t22*t3*abb3n40+t22*t36*abb3n55+t22*t37*abb3n50+t4*t9*ab&
         &b3n39+t5*t9*abb3n44+t7*t9*abb3n51+t1*t15*t6*abb3n70+t1*t21*t3*abb3n70+&
         &t16*t3*t6*abb3n70)
         return
      end if
      t36 = d(iv1,iv2)
      t2 = spvak1k2(iv2)
      t8 = spvak3k2(iv2)
      t18 = spvak6k4(iv2)
      t20 = k1(iv2)
      t23 = spvak1k5(iv2)
      t25 = spvak3k4(iv2)
      t26 = k2(iv2)
      t27 = k5(iv2)
      t28 = qshift(iv2)
      t29 = spvak6k2(iv2)
      t30 = t15*t29
      t31 = t21*t23
      t32 = t16*t29
      t33 = t21*t25
      t34 = t15*t25
      t35 = t16*t23
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t36*abb3n46+t1*t36*abb3n60+t36*t4*abb3n68+t36*t5&
         &*abb3n64+t36*t7*abb3n55)+t30*abb3n36+t31*abb3n36+t32*abb3n52+t33*abb3n&
         &52+k6(iv2)*t15*abb3n42+spvak5k2(iv2)*t15*abb3n38+spvak6k5(iv2)*t16*abb&
         &3n48+t1*t30*abb3n70+t1*t31*abb3n70+t10*t18*abb3n51+t10*t2*abb3n39+t10*&
         &t23*abb3n43+t10*t25*abb3n47+t10*t8*abb3n44+t11*t18*abb3n50+t11*t2*abb3&
         &n37+t11*t8*abb3n45+t12*t23*abb3n42+t13*t18*abb3n56+t13*t2*abb3n69+t13*&
         &t25*abb3n61+t13*t8*abb3n65+t14*t20*abb3n39+t14*t23*abb3n49+t14*t25*abb&
         &3n41+t14*t26*abb3n39+t14*t27*abb3n37+t14*t28*abb3n69+t15*t18*abb3n40+t&
         &15*t2*abb3n49+t15*t26*abb3n43+t15*t8*abb3n35+t16*t2*abb3n41+t16*t26*ab&
         &b3n47+t16*t28*abb3n61+t17*t23*abb3n38+t18*t9*abb3n51+t19*t20*abb3n44+t&
         &19*t23*abb3n35+t19*t26*abb3n44+t19*t27*abb3n45+t19*t28*abb3n65+t2*t9*a&
         &bb3n39+t20*t22*abb3n51+t22*t23*abb3n40+t22*t26*abb3n51+t22*t27*abb3n50&
         &+t22*t28*abb3n56+t24*t25*abb3n48+t3*t32*abb3n70+t3*t33*abb3n70+t34*t6*&
         &abb3n70+t35*t6*abb3n70+t8*t9*abb3n44)
         return
      end if
      t37 = d(iv2,iv3)
      t38 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t3 = spvak6k2(iv3)
      t4 = spvak1k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k2(iv3)*t36*abb3n68+spvak3k2(iv3)*t36*abb3&
         &n64+spvak6k4(iv3)*t36*abb3n55+t1*t36*abb3n60+t14*t37*abb3n68+t16*t37*a&
         &bb3n60+t18*t38*abb3n55+t19*t37*abb3n64+t2*t38*abb3n68+t22*t37*abb3n55+&
         &t25*t38*abb3n60+t38*t8*abb3n64)+t3*t34*abb3n70+t3*t35*abb3n70+t1*t15*t&
         &29*abb3n70+t1*t21*t23*abb3n70+t16*t29*t4*abb3n70+t21*t25*t4*abb3n70)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p0_dd_emnebardu_d3h1l1d
