module     p3_ud_emnebaruu_abbrevd61h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb61n1
   complex(ki), public :: abb61n2
   complex(ki), public :: abb61n3
   complex(ki), public :: abb61n4
   complex(ki), public :: abb61n5
   complex(ki), public :: abb61n6
   complex(ki), public :: abb61n7
   complex(ki), public :: abb61n8
   complex(ki), public :: abb61n9
   complex(ki), public :: abb61n10
   complex(ki), public :: abb61n11
   complex(ki), public :: abb61n12
   complex(ki), public :: abb61n13
   complex(ki), public :: rat2d61
   complex(ki), public :: abb61n15
   complex(ki), public :: abb61n16
   complex(ki), public :: abb61n17
   complex(ki), public :: abb61n18
   complex(ki), public :: abb61n19
   complex(ki), public :: abb61n20
   complex(ki), public :: abb61n21
   complex(ki), public :: abb61n22
   complex(ki), public :: abb61n23
   complex(ki), public :: abb61n24
   complex(ki), public :: abb61n25
   complex(ki), public :: abb61n26
   complex(ki), public :: abb61n27
   complex(ki), public :: abb61n28
   complex(ki), public :: abb61n29
   complex(ki), public :: abb61n30
   complex(ki), public :: abb61n31
   complex(ki), public :: abb61n32
   complex(ki), public :: abb61n33
   complex(ki), public :: abb61n34
   complex(ki), public :: abb61n35
   complex(ki), public :: abb61n36
   complex(ki), public :: abb61n37
   complex(ki), public :: abb61n38
   complex(ki), public :: abb61n39
   complex(ki), public :: abb61n40
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak3k4*spak5k6
      t4 = t3*spbk4k2
      t13 = TR*TR
      t5 = t13*t4*spbk6k1
      t6 = es234*t1
      t7 = NC*NC*t6
      t8 = c2*i_
      t9 = t8*spak3k4*spak5k6
      t10 = t9*spbk4k2
      t1 = es234*NC*t1
      abb61n1 = ((4.0_ki)*(t13*(2.0_ki)/t1*t10*spbk6k1-(t5/t7+t5/t6)))
      t5 = t8*spak2k3*spak5k6
      t11 = t2*spak2k3*spak5k6
      t12 = t13*t11*spbk2k1*spbk4k2
      t3 = t13*t3*spbk4k1*spbk4k2
      abb61n2 = ((8.0_ki)*(t13/t1*t5*spbk2k1*spbk4k2+t13/t1*t9*spbk4k1*spbk4k2)+&
      &(4.0_ki)*(-(t3/t7+t3/t6+t12/t7+t12/t6)))
      t3 = t11*spbk4k2
      t9 = t13*t3*spbk5k1
      t5 = t5*spbk4k2
      abb61n3 = ((4.0_ki)*(t13*(2.0_ki)/t1*t5*spbk5k1-(t9/t7+t9/t6)))
      t9 = t13*t4*spbk5k1
      abb61n4 = ((4.0_ki)*(t13*(2.0_ki)/t1*t10*spbk5k1-(t9/t7+t9/t6)))
      t9 = t13*t3*spbk6k1
      abb61n5 = ((4.0_ki)*(t13*(2.0_ki)/t1*t5*spbk6k1-(t9/t7+t9/t6)))
      t2 = t2*spak5k6
      t9 = t13*t2*spbk3k2
      t8 = t8*spak5k6
      abb61n6 = ((4.0_ki)*(t9/t6+t9/t7-t13*(2.0_ki)/t1*t8*spbk3k2))
      t9 = t13*t3*spbk5k2
      t11 = t13*t4*spbk5k4
      abb61n7 = ((8.0_ki)*(-(t13/t1*t5*spbk5k2+t13*t10/t1*spbk5k4))+(4.0_ki)*(t1&
      &1/t6+t11/t7+t9/t6+t9/t7))
      t3 = t13*t3*spbk6k2
      t4 = t13*t4*spbk6k4
      abb61n8 = ((8.0_ki)*(-(t13/t1*t5*spbk6k2+t13*t10/t1*spbk6k4))+(4.0_ki)*(t3&
      &/t6+t3/t7+t4/t6+t4/t7))
      t3 = t13*t2*spbk4k2
      t4 = t3/t6
      t3 = t3/t7
      t5 = t13*(2.0_ki)/t1*t8*spbk4k2
      t9 = t3+t4-t5
      abb61n9 = ((8.0_ki)*t9)
      abb61n10 = ((4.0_ki)*t9)
      t3 = t5-(t4+t3)
      abb61n11 = ((4.0_ki)*t3)
      abb61n12 = ((8.0_ki)*t3)
      t2 = t13*t2*spbk4k3
      abb61n13 = ((4.0_ki)*(t2/t6+t2/t7-t13*(2.0_ki)/t1*t8*spbk4k3))
      rat2d61 = 0
      rat2 = rat2 + rat2d61
      abb61n15 = -(abb61n1)
      abb61n16 = abb61n13
      abb61n17 = abb61n12
      abb61n18 = abb61n11
      abb61n19 = abb61n10
      abb61n20 = abb61n9
      abb61n21 = abb61n8
      abb61n22 = abb61n7
      abb61n23 = abb61n6
      abb61n24 = abb61n5
      abb61n25 = abb61n4
      abb61n26 = abb61n3
      abb61n27 = abb61n2
      abb61n28 = abb61n1
      abb61n29 = (-2.0_ki)*abb61n2
      abb61n30 = -(abb61n3)
      abb61n31 = -(abb61n4)
      abb61n32 = -(abb61n5)
      abb61n33 = -(abb61n6)
      abb61n34 = -(abb61n7)
      abb61n35 = -(abb61n8)
      abb61n36 = -(abb61n9)
      abb61n37 = -(abb61n10)
      abb61n38 = -(abb61n11)
      abb61n39 = -(abb61n12)
      abb61n40 = -(abb61n13)
   end subroutine
end module p3_ud_emnebaruu_abbrevd61h0
