module     p3_ud_emnebaruu_abbrevd13h1
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh1
   implicit none
   private
   complex(ki), public :: abb13n1
   complex(ki), public :: abb13n2
   complex(ki), public :: abb13n3
   complex(ki), public :: abb13n4
   complex(ki), public :: abb13n5
   complex(ki), public :: abb13n6
   complex(ki), public :: abb13n7
   complex(ki), public :: abb13n8
   complex(ki), public :: abb13n9
   complex(ki), public :: abb13n10
   complex(ki), public :: abb13n11
   complex(ki), public :: rat2d13
   complex(ki), public :: abb13n13
   complex(ki), public :: abb13n14
   complex(ki), public :: abb13n15
   complex(ki), public :: abb13n16
   complex(ki), public :: abb13n17
   complex(ki), public :: abb13n18
   complex(ki), public :: abb13n19
   complex(ki), public :: abb13n20
   complex(ki), public :: abb13n21
   complex(ki), public :: abb13n22
   complex(ki), public :: abb13n23
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   real(ki) :: t35
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak1k3*spak3k6
      t3 = t2*spbk4k3
      t35 = TR*TR
      t4 = t35*t3*spbk5k2
      t5 = (es12+es34-(es56+es345))*(es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = t4/t5
      t7 = t1*spak1k6*spak3k6
      t8 = t35*t7*spbk5k2*spbk6k4
      t9 = t8/t5
      t10 = t6-t9
      t11 = NC*NC*t5
      t4 = t4/t11
      t8 = t8/t11
      t12 = c2*i_
      t13 = NC*t5
      t14 = t35*t12/t13*spak1k3*spak3k6*spbk4k3*spbk5k2
      t15 = t35*t12/t13*spak1k6*spak3k6*spbk5k2*spbk6k4
      t16 = NC*c2
      t17 = t16*i_
      t18 = t17*spak1k3*spak3k6
      t19 = t18*spbk4k3
      t20 = t35*t19/t5*spbk5k2
      t21 = t17*spak1k6*spak3k6
      t22 = t35*t21/t5*spbk5k2*spbk6k4
      abb13n1 = ((2.0_ki)*(t10+t14+t22+t8-(t4+t20+t15)))
      t23 = es234*c1*i_
      t24 = es34*c1*i_
      t25 = es345*c1*i_
      t26 = es61*c1*i_
      t27 = es234*t16*i_
      t28 = es34*t16*i_
      t29 = es345*t16*i_
      t30 = es61*t16*i_
      t31 = es12*c1*i_
      t32 = t1*spak1k2
      t33 = TR*spbk5k2
      t33 = t33*t33
      t16 = es12*t16*i_
      t34 = t17*spak1k2
      abb13n2 = ((2.0_ki)*(t32*t33/t5*spak3k5*spak3k6*spbk4k3+t32*t33/t5*spak3k6&
      &*spak5k6*spbk6k4+t35*t16/t5*spak1k6*spak3k6*spbk5k2*spbk6k4+t35*t31/t5*sp&
      &ak1k3*spak3k6*spbk4k3*spbk5k2-(t35*t31/t5*spak1k6*spak3k6*spbk5k2*spbk6k4&
      &+t35*t16/t5*spak1k3*spak3k6*spbk4k3*spbk5k2+t33*t34/t5*spak3k6*spak5k6*sp&
      &bk6k4+t33*t34/t5*spak3k5*spak3k6*spbk4k3))+(4.0_ki)*(t35*t23/t5*spak1k6*s&
      &pak3k6*spbk5k2*spbk6k4+t35*t24/t5*spak1k3*spak3k6*spbk4k3*spbk5k2+t35*t25&
      &/t5*spak1k6*spak3k6*spbk5k2*spbk6k4+t35*t26/t5*spak1k3*spak3k6*spbk4k3*sp&
      &bk5k2+t35*t27/t5*spak1k3*spak3k6*spbk4k3*spbk5k2+t35*t28/t5*spak1k6*spak3&
      &k6*spbk5k2*spbk6k4+t35*t29/t5*spak1k3*spak3k6*spbk4k3*spbk5k2+t35*t30/t5*&
      &spak1k6*spak3k6*spbk5k2*spbk6k4-(t35*t30/t5*spak1k3*spak3k6*spbk4k3*spbk5&
      &k2+t35*t29/t5*spak1k6*spak3k6*spbk5k2*spbk6k4+t35*t28/t5*spak1k3*spak3k6*&
      &spbk4k3*spbk5k2+t35*t27/t5*spak1k6*spak3k6*spbk5k2*spbk6k4+t35*t26/t5*spa&
      &k1k6*spak3k6*spbk5k2*spbk6k4+t35*t25/t5*spak1k3*spak3k6*spbk4k3*spbk5k2+t&
      &35*t24/t5*spak1k6*spak3k6*spbk5k2*spbk6k4+t35*t23/t5*spak1k3*spak3k6*spbk&
      &4k3*spbk5k2)))
      t6 = t9-t6
      abb13n3 = ((8.0_ki)*(t20+t6-t22))
      abb13n4 = ((8.0_ki)*(t10+t22-t20))
      abb13n5 = ((6.0_ki)*(t35*t3/t5*spbk5k1+t35*t21/t5*spbk5k1*spbk6k4-(t35/t5*&
      &t7*spbk5k1*spbk6k4+t35*t19/t5*spbk5k1))+(2.0_ki)*(t35*t1/t5*spak2k6*spak3&
      &k6*spbk5k2*spbk6k4+t35*t17/t5*spak2k3*spak3k6*spbk4k3*spbk5k2-(t35*t17/t5&
      &*spak2k6*spak3k6*spbk5k2*spbk6k4+t35*t1/t5*spak2k3*spak3k6*spbk4k3*spbk5k&
      &2)))
      t3 = t1*spak3k6
      t9 = t17*spak3k6
      abb13n6 = ((2.0_ki)*(t35*t18/t5*spbk2k1*spbk4k3+t35/t5*t7*spbk2k1*spbk6k4+&
      &t35*t3/t5*spak5k6*spbk5k2*spbk6k4+t35*t1/t5*spak3k5*spak3k6*spbk4k3*spbk5&
      &k2-(t35*t17/t5*spak3k5*spak3k6*spbk4k3*spbk5k2+t35/t5*t9*spak5k6*spbk5k2*&
      &spbk6k4+t35*t21/t5*spbk2k1*spbk6k4+t35*t2/t5*spbk2k1*spbk4k3)))
      t1 = t1*spak1k5*spak3k6
      t2 = t12*spak1k5*spak3k6
      abb13n7 = ((4.0_ki)*(t35*t2/t13*spbk4k3*spbk5k2-t35*t1/t11*spbk4k3*spbk5k2&
      &))
      abb13n8 = ((4.0_ki)*(t35*t1/t11*spbk5k2*spbk6k4-t35*t2/t13*spbk5k2*spbk6k4&
      &))
      abb13n9 = ((4.0_ki)*(t15+t20+t4+t6-(t8+t22+t14)))
      t1 = t35*t3*spbk4k3
      t2 = t12*spak3k6
      abb13n10 = ((4.0_ki)*(t1/t11+t1/t5-(t35/t5*t9*spbk4k3+t35*t2/t13*spbk4k3))&
      &)
      t1 = t35*t3*spbk6k4
      abb13n11 = ((4.0_ki)*(t35*t2/t13*spbk6k4+t35/t5*t9*spbk6k4-(t1/t5+t1/t11))&
      &)
      rat2d13 = abb13n1
      rat2 = rat2 + rat2d13
      abb13n13 = abb13n2
      abb13n14 = abb13n11
      abb13n15 = abb13n10
      abb13n16 = abb13n9
      abb13n17 = -(abb13n3)
      abb13n18 = -(abb13n4)
      abb13n19 = -(abb13n5)
      abb13n20 = -(abb13n6)
      abb13n21 = -(abb13n7)
      abb13n22 = -(abb13n8)
      abb13n23 = ((2.0_ki)*abb13n9)
   end subroutine
end module p3_ud_emnebaruu_abbrevd13h1
