module     p3_ud_emnebaruu_abbrevd23h1
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh1
   implicit none
   private
   complex(ki), public :: abb23n1
   complex(ki), public :: abb23n2
   complex(ki), public :: abb23n3
   complex(ki), public :: abb23n4
   complex(ki), public :: abb23n5
   complex(ki), public :: abb23n6
   complex(ki), public :: abb23n7
   complex(ki), public :: abb23n8
   complex(ki), public :: abb23n9
   complex(ki), public :: abb23n10
   complex(ki), public :: abb23n11
   complex(ki), public :: abb23n12
   complex(ki), public :: abb23n13
   complex(ki), public :: rat2d23
   complex(ki), public :: abb23n15
   complex(ki), public :: abb23n16
   complex(ki), public :: abb23n17
   complex(ki), public :: abb23n18
   complex(ki), public :: abb23n19
   complex(ki), public :: abb23n20
   complex(ki), public :: abb23n21
   complex(ki), public :: abb23n22
   complex(ki), public :: abb23n23
   complex(ki), public :: abb23n24
   complex(ki), public :: abb23n25
   complex(ki), public :: abb23n26
   complex(ki), public :: abb23n27
   complex(ki), public :: abb23n28
   complex(ki), public :: abb23n29
   complex(ki), public :: abb23n30
   complex(ki), public :: abb23n31
   complex(ki), public :: abb23n32
   complex(ki), public :: abb23n33
   complex(ki), public :: abb23n34
   complex(ki), public :: abb23n35
   complex(ki), public :: abb23n36
   complex(ki), public :: abb23n37
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   real(ki) :: t45
   real(ki) :: t46
   real(ki) :: t47
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t45 = es234-(es61+es56)
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k3*spak3k6
      t4 = t3*spbk4k3
      t5 = t4*spbk5k2
      t46 = TR*mT
      t46 = t46*t46
      t6 = (es12+es34-(es56+es345))*t1
      t45 = t45*t45
      t7 = t45*t6
      t8 = t2*spak1k6
      t9 = t8*spak3k6
      t10 = t9*spbk5k2*spbk6k4
      t11 = t8*spak2k3
      t12 = t11*spbk4k2
      t13 = t12*spbk5k2
      t14 = es234*t45*t1
      t8 = t8*spak3k4
      t15 = t8*spbk4k2
      t16 = t15*spbk5k4
      t17 = c1*i_
      t18 = t17*spak1k3*spak3k6
      t19 = t18*spbk4k3
      t20 = t19*spbk5k2
      t6 = NC*t45*t6
      t21 = t17*spak1k6
      t22 = t21*spak3k6
      t23 = t22*spbk5k2*spbk6k4
      t24 = t21*spak2k3
      t25 = t24*spbk4k2
      t26 = t25*spbk5k2
      t27 = NC*t1
      t28 = es234*t45*t27
      t21 = t21*spak3k4
      t29 = t21*spbk4k2
      t30 = t29*spbk5k4
      t47 = TR*TR
      t31 = t47*t13
      t1 = t45*t1
      t32 = t47*t16
      t33 = t47*t26
      t27 = t45*t27
      t34 = t47*t30
      t35 = es234*c2*i_
      t36 = es56*c2*i_
      t37 = t36*spak1k6
      t38 = es61*c2*i_
      t39 = t38*spak1k6
      t40 = es234*c1*i_
      t41 = es56*c1*i_
      t42 = t41*spak1k6
      t43 = es61*c1*i_
      t44 = t43*spak1k6
      abb23n1 = ((8.0_ki)*(t46*t10/t7+t46*t13/t14+t46*t16/t14+t46*t20/t6-(t46*t5&
      &/t7+t46*t30/t28+t46*t26/t28+t46*t23/t6))+(4.0_ki/3.0_ki)*(t33/t27+t34/t27&
      &+t47*t37/t14*spak2k3*spbk4k2*spbk5k2+t47*t37/t14*spak3k4*spbk4k2*spbk5k4+&
      &t47*t39/t14*spak2k3*spbk4k2*spbk5k2+t47*t39/t14*spak3k4*spbk4k2*spbk5k4+t&
      &47*t37/t7*spak3k6*spbk5k2*spbk6k4+t47*t39/t7*spak3k6*spbk5k2*spbk6k4+t47*&
      &t35/t7*spak1k3*spak3k6*spbk4k3*spbk5k2+t47*t40/t6*spak1k6*spak3k6*spbk5k2&
      &*spbk6k4+t47*t41/t6*spak1k3*spak3k6*spbk4k3*spbk5k2+t47*t43/t6*spak1k3*sp&
      &ak3k6*spbk4k3*spbk5k2-(t47*t40/t6*spak1k3*spak3k6*spbk4k3*spbk5k2+t47*t38&
      &/t7*spak1k3*spak3k6*spbk4k3*spbk5k2+t47*t36/t7*spak1k3*spak3k6*spbk4k3*sp&
      &bk5k2+t47*t35/t7*spak1k6*spak3k6*spbk5k2*spbk6k4+t47*t44/t6*spak3k6*spbk5&
      &k2*spbk6k4+t47*t42/t6*spak3k6*spbk5k2*spbk6k4+t47*t44/t28*spak3k4*spbk4k2&
      &*spbk5k4+t47*t44/t28*spak2k3*spbk4k2*spbk5k2+t47*t42/t28*spak3k4*spbk4k2*&
      &spbk5k4+t47*t42/t28*spak2k3*spbk4k2*spbk5k2+t32/t1+t31/t1)))
      t1 = t2*spak1k5
      t27 = t1*spak3k6
      t35 = t17*spak1k5
      t36 = t35*spak3k6
      abb23n2 = ((4.0_ki)*(t47*t36/t6*spbk4k3*spbk5k2-t47*t27/t7*spbk4k3*spbk5k2&
      &))
      t37 = t2*spak3k6
      t38 = t17*spak3k6
      abb23n3 = ((8.0_ki)*(t47*t37/t7*spbk4k3-t47*t38/t6*spbk4k3))
      t39 = TR*sqrt((mT*mT))
      t39 = t39*t39
      abb23n4 = ((8.0_ki)*(t10*t39/t7+t13/t14*t39+t16/t14*t39+t20*t39/t6-(t39*t5&
      &/t7+t30/t28*t39+t26/t28*t39+t23*t39/t6)))
      abb23n5 = ((4.0_ki)*(t47*t27/t7*spbk5k2*spbk6k4+t47*t1/t14*spak2k3*spbk4k2&
      &*spbk5k2+t47*t1/t14*spak3k4*spbk4k2*spbk5k4-(t47*t35/t28*spak3k4*spbk4k2*&
      &spbk5k4+t47*t35/t28*spak2k3*spbk4k2*spbk5k2+t47*t36/t6*spbk5k2*spbk6k4)))
      abb23n6 = ((4.0_ki)*(t47*t25/t28*spbk5k1+t47*t4/t7*spbk5k1+t47*t22/t6*spbk&
      &5k1*spbk6k4-(t47/t7*t9*spbk5k1*spbk6k4+t47*t19/t6*spbk5k1+t47*t12/t14*spb&
      &k5k1)))
      abb23n7 = ((4.0_ki)*(t47*t29/t28*spbk5k1-t47*t15/t14*spbk5k1))
      t1 = t47*t5/t7
      t4 = t47*t10/t7
      t5 = t31/t14
      t10 = t32/t14
      t12 = t47*t20/t6
      t13 = t47*t23/t6
      t15 = t33/t28
      t16 = t34/t28
      t19 = t1+t13+t15+t16-(t5+t4+t12+t10)
      abb23n8 = ((16.0_ki)*t19)
      abb23n9 = ((8.0_ki)*t19)
      abb23n10 = ((16.0_ki)*(t10+t12+t4+t5-(t16+t15+t13+t1)))
      t1 = t2*spak2k3
      t4 = t17*spak2k3
      abb23n11 = ((8.0_ki)*(t47*t4/t28*spbk4k2+t47*t38/t6*spbk6k4-(t47*t37/t7*sp&
      &bk6k4+t47*t1/t14*spbk4k2)))
      t5 = t2*spak3k4
      t10 = t17*spak3k4
      abb23n12 = ((8.0_ki)*(t47*t11/t14*spbk2k1*spbk4k2+t47/t14*t8*spbk4k1*spbk4&
      &k2+t47*t18/t6*spbk2k1*spbk4k3+t47/t7*t9*spbk2k1*spbk6k4+t47*t1/t14*spak5k&
      &6*spbk4k2*spbk5k2+t47/t14*t5*spak5k6*spbk4k2*spbk5k4+t47*t37/t7*spak5k6*s&
      &pbk5k2*spbk6k4+t47*t2/t7*spak3k5*spak3k6*spbk4k3*spbk5k2-(t47*t17/t6*spak&
      &3k5*spak3k6*spbk4k3*spbk5k2+t47*t38/t6*spak5k6*spbk5k2*spbk6k4+t47*t4/t28&
      &*spak5k6*spbk4k2*spbk5k2+t47*t10/t28*spak5k6*spbk4k2*spbk5k4+t47*t3/t7*sp&
      &bk2k1*spbk4k3+t47*t24/t28*spbk2k1*spbk4k2+t47*t22/t6*spbk2k1*spbk6k4+t47*&
      &t21/t28*spbk4k1*spbk4k2)))
      abb23n13 = ((8.0_ki)*(t47*t10/t28*spbk4k2-t47/t14*t5*spbk4k2))
      rat2d23 = abb23n1
      rat2 = rat2 + rat2d23
      abb23n15 = abb23n4
      abb23n16 = abb23n13
      abb23n17 = abb23n12
      abb23n18 = abb23n11
      abb23n19 = abb23n10
      abb23n20 = abb23n9
      abb23n21 = abb23n8
      abb23n22 = abb23n7
      abb23n23 = abb23n6
      abb23n24 = abb23n5
      abb23n25 = abb23n3
      abb23n26 = abb23n2
      abb23n27 = -(abb23n2)
      abb23n28 = -(abb23n3)
      abb23n29 = -(abb23n5)
      abb23n30 = -(abb23n6)
      abb23n31 = -(abb23n7)
      abb23n32 = -(abb23n8)
      abb23n33 = (-2.0_ki)*abb23n9
      abb23n34 = -(abb23n10)
      abb23n35 = -(abb23n11)
      abb23n36 = -(abb23n12)
      abb23n37 = -(abb23n13)
   end subroutine
end module p3_ud_emnebaruu_abbrevd23h1
