module     p7_dubar_emnebargg_abbrevd1h0
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh0
   implicit none
   private
   complex(ki), public :: abb1n1
   complex(ki), public :: abb1n2
   complex(ki), public :: abb1n3
   complex(ki), public :: abb1n4
   complex(ki), public :: abb1n5
   complex(ki), public :: abb1n6
   complex(ki), public :: abb1n7
   complex(ki), public :: abb1n8
   complex(ki), public :: abb1n9
   complex(ki), public :: abb1n10
   complex(ki), public :: abb1n11
   complex(ki), public :: rat2d1
   complex(ki), public :: abb1n13
   complex(ki), public :: abb1n14
   complex(ki), public :: abb1n15
   complex(ki), public :: abb1n16
   complex(ki), public :: abb1n17
   complex(ki), public :: abb1n18
   complex(ki), public :: abb1n19
   complex(ki), public :: abb1n20
   complex(ki), public :: abb1n21
   complex(ki), public :: abb1n22
   complex(ki), public :: abb1n23
   complex(ki), public :: abb1n24
   complex(ki), public :: abb1n25
   complex(ki), public :: abb1n26
   complex(ki), public :: abb1n27
   complex(ki), public :: abb1n28
   complex(ki), public :: abb1n29
   complex(ki), public :: abb1n30
   complex(ki), public :: abb1n31
   complex(ki), public :: abb1n32
   complex(ki), public :: abb1n33
   complex(ki), public :: abb1n34
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   real(ki) :: t17
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = TR*c3
      t2 = t1*i_
      t3 = t2*spak2k5
      t4 = t3*spak3k4
      t5 = (es34+wW*mW*i_-mW*mW)*spak5k6*spak5k6
      t17 = NC*TR
      t6 = t17*c1
      t7 = t6*i_
      t8 = t7*spak2k5
      t9 = t8*spak3k4
      t10 = t17*c2
      t11 = t10*i_
      t12 = t11*spak2k5
      t13 = t12*spak3k4
      abb1n1 = ((2.0_ki)*(t4/t5*spbk4k1*spbk6k4+(2.0_ki)/t5*t9*spbk4k1*spbk6k4-t&
      &13/t5*spbk4k1*spbk6k4))
      t1 = es56*t1*i_
      t6 = es56*t6*i_
      t10 = es56*t10*i_
      abb1n2 = ((2.0_ki)*((2.0_ki)*t1/t5*spak3k4*spbk4k1+t10/t5*spak3k4*spbk4k1+&
      &t6/t5*spak3k4*spbk4k1))
      abb1n3 = ((2.0_ki)*(-(t6/t5+t10/t5+(2.0_ki)*t1/t5)))
      t2 = t2*spak2k6
      t14 = t2*spak3k4
      t7 = t7*spak2k6
      t15 = t7*spak3k4
      t11 = t11*spak2k6
      t16 = t11*spak3k4
      abb1n4 = ((2.0_ki)*(t14/t5*spbk4k1*spbk5k4+(2.0_ki)*t16/t5*spbk4k1*spbk5k4&
      &-t15/t5*spbk4k1*spbk5k4))
      abb1n5 = ((2.0_ki)*((2.0_ki)*t11/t5*spbk5k1+t2/t5*spbk5k1-t7/t5*spbk5k1))
      abb1n6 = ((2.0_ki)*(t3/t5*spbk6k1+(2.0_ki)/t5*t8*spbk6k1-t12/t5*spbk6k1))
      abb1n7 = ((4.0_ki)*(t1/t5*spak2k3*spbk4k1-(t8/t5*spak3k6*spbk5k1*spbk6k4+t&
      &11/t5*spak3k5*spbk5k4*spbk6k1))+(2.0_ki)*(t10/t5*spak2k3*spbk4k1+t6/t5*sp&
      &ak2k3*spbk4k1+t12/t5*spak3k6*spbk5k1*spbk6k4+t7/t5*spak3k5*spbk5k4*spbk6k&
      &1-(t3/t5*spak3k6*spbk5k1*spbk6k4+t2/t5*spak3k5*spbk5k4*spbk6k1)))
      abb1n8 = ((2.0_ki)*(t4/t5*spbk5k4*spbk6k4+(2.0_ki)/t5*t9*spbk5k4*spbk6k4-t&
      &13/t5*spbk5k4*spbk6k4))
      abb1n9 = ((2.0_ki)*(t12/t5*spbk6k5-((2.0_ki)/t5*t8*spbk6k5+t3/t5*spbk6k5))&
      &)
      abb1n10 = ((2.0_ki)*(t14/t5*spbk5k4*spbk6k4+(2.0_ki)*t16/t5*spbk5k4*spbk6k&
      &4-t15/t5*spbk5k4*spbk6k4))
      abb1n11 = ((2.0_ki)*((2.0_ki)*t11/t5*spbk6k5+t2/t5*spbk6k5-t7/t5*spbk6k5))
      rat2d1 = 0
      rat2 = rat2 + rat2d1
      abb1n13 = -(abb1n1)
      abb1n14 = abb1n11
      abb1n15 = abb1n10
      abb1n16 = abb1n9
      abb1n17 = abb1n8
      abb1n18 = abb1n7
      abb1n19 = abb1n6
      abb1n20 = abb1n5
      abb1n21 = abb1n4
      abb1n22 = abb1n3
      abb1n23 = abb1n2
      abb1n24 = abb1n1
      abb1n25 = -(abb1n2)
      abb1n26 = -(abb1n3)
      abb1n27 = -(abb1n4)
      abb1n28 = -(abb1n5)
      abb1n29 = -(abb1n6)
      abb1n30 = (-2.0_ki)*abb1n7
      abb1n31 = -(abb1n8)
      abb1n32 = -(abb1n9)
      abb1n33 = -(abb1n10)
      abb1n34 = -(abb1n11)
   end subroutine
end module p7_dubar_emnebargg_abbrevd1h0
